
;**********************************************************************

	list      p=12F683        ; list directive to define processor
	#include <P12F683.inc>    ; processor specific variable definitions

	errorlevel  -302          ; suppress message 302 from list file
;	errorlevel  -209          ; suppress message 302 from list file
	__CONFIG   _FCMEN_ON & _IESO_OFF & _CP_OFF & _CPD_OFF & _BOD_OFF & _MCLRE_OFF & _WDT_OFF & _PWRTE_OFF & _INTRC_OSC_NOCLKOUT 
;	__CONFIG   _FCMEN_ON & _IESO_OFF & _CP_OFF & _CPD_OFF & _BOD_OFF & _MCLRE_OFF & _WDT_OFF & _PWRTE_OFF & _INTRC_OSC_CLKOUT 

; '__CONFIG' directive is used to embed configuration word within .asm file.

;² , Ͳ   Ҳ ̲ в,    .ASM
	#include <KOROTKO.INC>    ;

W					EQU		0
F					EQU		1
StopByte  			EQU	    B'10101010' ;  ,           (B'10101010')
Poch_X_Adr_Gist		EQU		D'69'		;  -  (  )
Kinc_X_Adr_Gist		EQU		D'15'		;  -   
KilxkStovpchGist	EQU		D'50'		;     = 69 - 15 - 4 = 50
;;;;;;;;;;;
      cblock  20H		;   96   
						;( 32        1    0xA0 )
	W_TEMP           		; 1 variable used for context saving 
	STATUS_TEMP      		; 2 variable used for context saving

	PerByte				; 3     LCD Nokia 5510

	NomerBita			; 4      
	ByteIndykaciji		; 5   (    )
	SLRIndykaciji			; 6   ,   ,    

	Y_adresa				; 7 Y      LCD	
	KONTR_IND_REG			; 8   ,    :
					; 0- 0/1 - Ͳ/     ?
					; 1- 0/1 - Ͳ/     ?
					; 2- 0/1 - Ͳ/        10,20.30
					; 3- 0/1 - Ͳ/     ? (        )
					; 4- 0/1 - Ͳ/
					; 5- 0/1 - Ͳ/
					; 6- 0/1 - Ͳ/
					; 7- 0/1 - Ͳ/
	X_Adr_Zbereg			; 9   X-      	
	Y_Adr_Zbereg			; 10   Y-      	
	GistByte				; 11      (00000001->00000010->00000100)


	Cyfra				; 12  ,    
	Znach1				; 13    
	Znach10				; 14    



	ByteChisla			; 15     

	FSR_PotStovpchyka		; 16 FSR   ( REZULT1-   - )
	AdresaFSR			; 17    
	DaniINDF				; 18     
	DaniEEPROM			; 19     -     EEPROM
	AdresaEEPROM			; 20     EEPROM
	KilxkPeriodivT1ZaVymir	; 21 -    ( 
                            ;     1,   1  (  = 2 ,  . 1:8,
							;     ) *33
							;    = 33 . 
							;  (D'33' = 0x21)    EEPROM

	KilxkVymirivZaGodynu	; 22 : 3600 . /(KilxkPeriodivT1ZaVymir * PeriodT1(.)) = 3600./(34*1.) = 106


	NomerRegymu			; 23     (50 , 50 , 50 , 50 )

	PotMin				; 24       (  )
	PotMax				; 25       (  )
	PotSerZnach			; 26       ( ,  )

	KONTR_REG   	 		; 27   ,   :
	                 
					; 0- 0/1 - Ͳ/ - 
					; 1- 0/1 -  ()    /   
					; 2- 0/1 -  ( )    /  
					; 3- 0/1 - /     
					; 4- 0/1  -   EEPROM /   
                    ; 5- 0/1 -  /   99  
                  	; 6- 0/1 -   / в     
                  	; 7- 0/1 -  / Ͳ -     1-       EEPROM
	RezPotVym			; 28   
	SumaDanyhByte0		; 29     (  )
	SumaDanyhByte1		; 30     (  )

	KilxkistxVymiriv		; 31  ,     .
	X_adresa				; 32       LCD
;    ,    
	REZULT1, REZULT2, REZULT3, REZULT4, REZULT5, REZULT6, REZULT7, REZULT8, REZULT9, REZULT10
	REZULT11,REZULT12,REZULT13,REZULT14,REZULT15,REZULT16,REZULT17,REZULT18,REZULT19,REZULT20
	REZULT21,REZULT22,REZULT23,REZULT24,REZULT25,REZULT26,REZULT27,REZULT28,REZULT29,REZULT30
	REZULT31,REZULT32,REZULT33,REZULT34,REZULT35,REZULT36,REZULT37,REZULT38,REZULT39,REZULT40
	REZULT41,REZULT42,REZULT43,REZULT44,REZULT45,REZULT46,REZULT47,REZULT48,REZULT49,REZULT50
;  ,  : ( 36+50Rezult+7+13SLR=MAX=96 )**************************

	SLR1              	; 82 VyrahuvSerednxogo;             
						; 
						;   Deseretv		;              ;
						;   MinSerMax		;  ,       .
	SLR2					; 83 VyrahuvSerednxogo;             

	SLR3					; 84 VyvidGistRezVym	;    ,  
							; VyrahuvSerednxogo   

	SLR4					; 85   VyvidZobrMasyvu			;    REZULT1...30...48 (   )

	SLR5					; 86     ,   
						;       0  9
						;   PROBIL		;   -   / (6x8)

	SLR7				; 87     ,   
						; Iks						
						; IndRegymu1        0  9

	SLR11				; 88		ZsuvGrafika

	SLR12				; 89		ZsuvGrafika

	SLR13				; 90  VyvidZobrMasyvu    REZULT1..50

	TerminRobotyBatarejiDib		; 91      	

	OdnaVosxmaTermBatDib		; 92        

	GodynyRobotyBatareji		; 93   

	DobyRobotyBatareji			; 94   

	StovpchykGistogramy			; 95   ( 0  40)

;	FIXATOR				; 96   2


;  ,  : **************************

	endc
;;;;;;;;;;;
    CBLOCK  0xA0	; 32        1    0xA0 
	B1Zatrymka			; 1     -   					;

	B1Sekundy		; 2   (60-00)
	B1Hvylyny		; 3   (60-00)
	B1Godyny		; 4    (24-00)
	B1Doby			; 5      (30-00)    30

	B1LichGodynUseredn	; 6   
						;(3600/34()=  106  
	B1LichDobovUseredn	; 7   
						;  106x24  

	B1KONTR_REG2		; 9     2
	B1KONTR_REG3		; 10     3

	B1PotRezZaGodynu	; 11       	
	B1PotRezZaDobu		; 12       	

	B1SumaDanyh2Byte0		; 13       2 (  )
	B1SumaDanyh2Byte1		; 14       2 (  )
	B1SumaDanyh3Byte0		; 15       3 (  )
	B1SumaDanyh3Byte1		; 16       3 (  )
	
	B1KilxkistxVymiriv2		; 17  ,     .
	B1KilxkistxVymiriv3		; 18  ,     .

	B1X_adresa2				; 19       LCD   2
	B1X_adresa3				; 20       LCD   3

	B1KilxkPerezap			; 21     (  ,   = 48-2 = 46)
	B1Rezultat				; 22        .    .
	B1KilxkElementiv			; 23      EEPROM     REZULT1...30...48

	B1Intcon_TEMP				; 24    INTCON    / 

	OPTION_TEMP      		; 25variable used for context saving

	B1SLR1				; 26  


	ENDC
;**********************************************************************
#DEFINE DatCom		GPIO,0
#DEFINE ResetLCD	GPIO,1
;#DEFINE ChipEnDis	GPIO,2     ; 2-  3- GPIO
#DEFINE DataLine	GPIO,4
#DEFINE ClockLine	GPIO,5
;**********************************************************************
 ;initialize eeprom locations     
	ORG	0x2100
;  84  (00-83)    "00/(00-00)"
	DE	B'00111000',B'01000100',B'10000010',0x00,B'01111100',B'10000010',B'10000010',B'10000010',B'01111100',0x00,B'01111100',B'10000010',B'10000010',B'10000010',B'01111100',0x00             	    ; 00) 
	DE	B'00010000',B'00010000',B'00010000',0x00,B'01111100',B'10000010',B'10000010',B'10000010',B'01111100',0x00,B'01111100',B'10000010',B'10000010',B'10000010',B'01111100',0x00;                    ; 00-
;  	; (
;	DE	B'10000010',B'01000100',B'00111000',0x00,B'00011100',B'01100010',B'10100010',B'10011100',0x00,B'00011100',B'00100010',B'00100010',B'00011100',0x00   ;                                         ; (
;  	;  /
;	DE	B'00010010',B'00101010',B'00101010',B'00100100',B'01000000',B'00100000',B'00010000',B'000001000',B'00000100'            					                                                 ; /
;  	; (
	DE	B'10000010',B'01000100',B'00111000',0x00,B'00010100',B'00100010',B'00100010',B'00011100',0x00,B'00011110',B'00101000',B'00101000',B'00011110',0x00   ;                                         ; (
;  	; /
	DE	B'00111110',B'00001000',B'00001000',B'00110000',B'01000000',B'00100000',B'00010000',B'000001000',B'00000100'            					                                                 ; /

	DE	B'01110010',B'10001000',B'10001000',B'10001000',B'11111110',0x00,B'00100010',B'00010100',B'00001000',B'00111110',0x00,B'00111110',B'00010000',B'00001000',B'00010000',B'00111110',0x00			; 
	DE	B'01111100',B'10000010',B'10000010',B'10000010',B'01111100',0x00,B'01111100',B'10000010',B'10000010',B'10000010',B'01111100',0x00	;,0x00				 									; 00 



 

;**********************************************************************
	ORG     0x000             ; processor reset vector
	goto    main              ; go to beginning of program
	
;*******************************************************************************************************************
Podija	ORG     0x004             ;  Ѳ 
	BTFSC	INTCON,GIE
	GOTO	Podija		;    ( ,   )
;-------------------------------
; W,STATUS,OPTION_REG 
;-------------------------------
	MOVWF	W_TEMP
	SWAPF	W_TEMP,F
	SWAPF	OPTION_REG,W
	MOVWF	OPTION_TEMP
	SWAPF	STATUS,W
	MOVWF	STATUS_TEMP

;-------------------------------
	BTFSC	INTCON,INTF	;    RB0/INT (  )
	GOTO	IMP_Geigera	;     
	BTFSC	INTCON,GPIF	;      ( RB4("),RB5(""),RB6,RB7
	GOTO	KnopkaNat	;  
	BTFSC	PIR1,TMR1IF	;     1
	GOTO	PEREP_Timer1	;   1
	GOTO Podija_End
IMP_Geigera
	BCF	INTCON,INTF	;clear the RB0/INT flag
	CALL  VhidnyjImpuls	; BXB0           GP2
	GOTO Podija_End
KnopkaNat
	BCF	INTCON,GPIF	;     
	BTFSS   GPIO,3
	CALL	ZminaRegymu		; BXB0       (50 , 48 , 30 , 48 )
	GOTO Podija_End
PEREP_Timer1	;   1
	BCF PIR1,TMR1IF        ;
	CALL TIMER1          ;
	GOTO Podija_End

Podija_End
;--------------------------------
; W,STATUS,OPTION_REG 
;--------------------------------
	SWAPF	STATUS_TEMP,W
	MOVWF	STATUS
	SWAPF	OPTION_TEMP,W
	MOVWF	OPTION_REG

	SWAPF	W_TEMP,W
;--------------------------------

	retfie                    ; return from interrupt
;*******************************************************************************************************************
main
	BANK1 		;   1
	clrf      ANSEL
	CLRF TRISIO
	MOVLW        b'00001100'; GP3,GP2  
	MOVWF      TRISIO
 	MOVLW     b'00000000'  ;1-    , 0 -  (7-	, 
	MOVWF OPTION_REG       ;  )
	MOVLW     b'00001100'  ;    GP3,GP2
;	MOVWF WPU       ;;	MOVLW        b'00000010'  ;    31
							;b'_XXX_ _ _ _' 000 - 31,  001 - 125, 010 - 250
							;               011 - 500, 100 - 1,   101 - 2, 
							;               110 - 4,   111 - 8.
;	MOVLW        b'01000010'  ;    1/   1:1  1 = 262.
	MOVLW        b'01010010'  ;    2/   1:8  1 = 1,048576 .
;	MOVLW        b'01100010'  ;    4
;	MOVLW		b'00110010'  ;    500///////////////////////////
;	MOVLW		b'00100010'  ;    250///////////////////////////
;	MOVLW		b'00010010'  ;    125///////////////////////////
;;	MOVLW        b'01110010'  ;    8///////////////////////////
	movwf	OSCCON
;	MOVLW        b'11001000'   ;;;;11001000 - , (O),GPIO change (GP3   IOC)
;	MOVLW        b'01011000'   ;;;;11001000 - , (1),GPIO change (GP3   IOC)
;	MOVLW        b'11011000'   ;;;
	MOVLW        b'01011000'   ;;;
	movwf	INTCON             ;
	MOVLW        b'00001100'
	movwf	IOC                     ;;;;;;;      GP2,GP3   ; GP4(pin3)-, GP3(pin4)-.

	MOVLW  b'00000001'   ;    1
	movwf PIE1

	BANK0		;   0
 	movlw  07h         ;     =B'0000111'
	movwf   CMCON0      ;   
;	MOVLW   b'00000001'  ; 1 + 00=1:1, 1 
	MOVLW   b'00110001'  ; 1 + 11=1:8, 1 
;	MOVLW   b'00010001'  ; 1 + 01=1:2, 1 
	movwf   T1CON       ;       Fosc/4

;======================================================================================
	CALL INIT_LCD     ; B0  LCD  

	CLRF	KONTR_REG
	CLRF	RezPotVym		;   
	CLRF	KONTR_IND_REG

	CALL	Ochyshchennja		; B0     (  )		; 
	;;
	CLRF	Cyfra
	;;
	CLRF	KilxkistxVymiriv	;  ,     .
	CLRF	PotMin			;       (  )
	CLRF	PotMax			;       (  )
	CLRF	PotSerZnach		;       ( ,  )
	CLRF	SumaDanyhByte0		;     (  )
	CLRF	SumaDanyhByte1	;     (  )

	MOVLW	REZULT1		; 
	MOVWF	FSR
	MOVF_F	FSR,FSR_PotStovpchyka; FSR   ( REZULT1-   - )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     (    EEPROM(0x00 - 0xD'83'(83)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	CLRF	X_adresa	
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'5'	; 
	CALL	Vst_Y_Adr		; B0 

;      84  EEPROM ( 000 - D'83')
	CLRF	AdresaEEPROM
	LOADF	SLR1,D'84'
ShcheByte1Str
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	DaniEEPROM,PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	INCF	AdresaEEPROM,F
	DECFSZ	SLR1,F
	GOTO	ShcheByte1Str


	LOADF	NomerRegymu,D'1'	;     (50 , 48 , 30 , 48 )
	CALL	IndRegymu1		;   1   

	CALL	VyvidSerMaxMinKilxkVym		;  , ,  
;							;   

	LOADF	X_adresa,Poch_X_Adr_Gist	;  -   
	CALL	Vst_X_Adr		; B0  X     LCD
	CALL	ViknoGist		;
	CALL	VyvidRezPotVym	; B0    	RezPotVym (  ) 
							;	    

;...... ,      ""
;  0xFF  0xFE    (       )
	BTFSC	GPIO,3
	GOTO	ZvychajnyjStart
;   ""   -      
	BSF		KONTR_REG,6		;       
	CALL 	InitEEPROM		; B0 
	BCF		KONTR_REG,6		;       
;-------    ""    3.   
;       (        2,3
	LOADF	SLR13,D'8'
Vytrymka3sek
	CLRF	SLR4
PAUZA
	CALL	Zatr1ms5BXB0    ;  1,5  . . 2M
	INCFSZ	SLR4,F		; 1,5 x 256 = 0,384
	GOTO	PAUZA
	DECFSZ	SLR13,F
	GOTO	Vytrymka3sek	; 0,384  8 = . 3.
;-------
	BTFSC	GPIO,3
	GOTO	ZvychajnyjStart
;-------
	BSF		KONTR_REG,4		;      
	BTFSS	GPIO,3			;   
	GOTO	$-1				;
	CALL 	InitEEPROM		; B0 4-  . . - 0/1  -   EEPROM /    0xFF  0xFE, 
							;        ( -20) 
	BCF		KONTR_REG,4		;      
	GOTO	Chytaty_Z_EEPROM
ZvychajnyjStart
;.........    EEPROM,       EEPROM ........................ 
	LOADF	AdresaEEPROM,0xFF		;    EEPROM   0xFF
									;    
									;  1   (=D'33'  -20   1 = 1,048576 )	
									;  0xFF,     
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT


	MOVLW	0xFF					;
	SUBWF	DaniEEPROM,W			;    ,       FF
	BTFSC	STATUS,Z				; 0/1 -  FF / FF
	CALL	InitEEPROM			; B0  EEPROM   

;    EEPROM   
Chytaty_Z_EEPROM
	LOADF	AdresaEEPROM,0xFF
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	DaniEEPROM,KilxkPeriodivT1ZaVymir; -    ( 
;                               	;   1,   1  ( .1:8   .)
								; *33 = 33 .

	LOADF	AdresaEEPROM,0xFE
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	DaniEEPROM,KilxkVymirivZaGodynu; -      ( 
;                               	; 3600 / 34 = 106

	LOADF	AdresaEEPROM,0xFD
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	DaniEEPROM,TerminRobotyBatarejiDib		;      
	LOADF	AdresaEEPROM,0xFC
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	DaniEEPROM,GodynyRobotyBatareji		; 93   
	LOADF	AdresaEEPROM,0xFB
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	DaniEEPROM,DobyRobotyBatareji		; 30   

;  2- 
	BANK1
	LOADF	EEADR,D'84'
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	EEDAT,B1KONTR_REG2

	INCF	EEADR,F
;        ,
;      =0,
;      ʲͲ   2-  3- 
	CLRF	B1PotRezZaGodynu	;
	INCF	EEADR,F
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	EEDAT,B1SumaDanyh2Byte0
	INCF	EEADR,F
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	EEDAT,B1SumaDanyh2Byte1
	INCF	EEADR,F
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	EEDAT,B1KilxkistxVymiriv2
	INCF	EEADR,F
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	EEDAT,B1X_adresa2


;  3- 
	LOADF	EEADR,D'140'
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	EEDAT,B1KONTR_REG3
	INCF	EEADR,F
;        ,
;      =0,
;      ʲͲ   2-  3- 
	CLRF	B1PotRezZaDobu
	INCF	EEADR,F
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	EEDAT,B1SumaDanyh3Byte0
	INCF	EEADR,F
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	EEDAT,B1SumaDanyh3Byte1
	INCF	EEADR,F
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	EEDAT,B1KilxkistxVymiriv3
	INCF	EEADR,F
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	EEDAT,B1X_adresa3
	BANK0
;............................................................................................................................
; 
;   
	MOVF	KilxkVymirivZaGodynu,W	; 32 : 3600 . /(KilxkPeriodivT1ZaVymir * PeriodT1(.))	
									; =106  -20,в = 3600 / 34 = 106
		BANK1
	MOVWF	B1LichGodynUseredn	;   
						;(3600/34()=  106  
	MOVLW	D'24'
	MOVWF	B1LichDobovUseredn	;   
						;  (106x) 24  

	LOADF	B1Sekundy,D'60'		;   (60-00)
	LOADF	B1Hvylyny,D'60'		; 3   (60-00)
	LOADF	B1Godyny,D'24'		; 4    (24-00)

	BANK0
;  1/8        (    )
	MOVF_F	TerminRobotyBatarejiDib,SLR1
	RRF		SLR1,F		; /2
	BCF		SLR1,7
	RRF		SLR1,F		; /2	(/4)		
	BCF		SLR1,7
	RRF		SLR1,F		; /2	(/8)
	BCF		SLR1,7
	MOVF_F	SLR1,OdnaVosxmaTermBatDib		; 92        

	CALL	IndAkumuljatora		; B0     

;;; в  1  Ĳ  1,048576  1 
;   1   0x0B  0xDC ,
;  3036
; 1,048576 / 65536 (.   16- ) = 16
;(1,048576 - 1.)/0,000016 = 3036 = 0X0B,0xDC
	LOADF	TMR1H,0x0B
	LOADF	TMR1L,0xDC	

	BSF		INTCON,GIE		;  .
;**************************************************************************************
;    
;**************************************************************************************
CYCLE                      ;    
;	BTFSC	KONTR_REG,4
;	CALL	ZminaRegIndykaciji
;	BCF		KONTR_REG,4

	GOTO      CYCLE 
;**************************************************************************************

;;;;;;;;;;;;;ϲ;;;;;;;;;;;;;;;;;
; _________B0 -     0,  -  0
; _________B1 -     1,  -  1
; _________B0B1 -     ,   
; _________BXBO -   ,  -  0
;..............
; INIT_LCD     	; B0  LCD
; PER_BYTE_COM	; B0   -  PIC12F683  LCD Nokia 5510
; PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
;                   ;;;;;;PER_BYTE		; B0     PIC12F683  LCD Nokia 5510
; RESET			; B0     LCD
;
; VyvidGistRezVym			; B0    ,  
; ZsuvViknaTaGistogramy		; B0       
;					;    ,KONTR_REG,3 = 1,    
;
; ZsuvGrafika		; B0       
; Vertykalx 		; B0     KONTR_REG,4  7 -   .,     
; Ochyshchennja		; B0     (  )
; ViknoGist			; B0    
; VertVisx			; B0       
; PotochnaZmina		; B0    RezPotVym
			; +    (RezPotVym)  + 
			; +      99(. )
			;     KONTR_REG,5  
; VyvidSerMaxMinKilxkVym	; B0  , ,  
;							;   
; IndAkumuljatora			; B0     
; IndKilxkVymiriv			; B0   ,     
;!!!!!!!!	ZminaRegymu ; BXB0       (50 ,  ,  )
; IndRegymu1 (2,3,4)		; B0  1(2,3,4):"- - " (,,)   
;
; Vst_X_Adr					; B0  X     LCD
; Vst_Y_Adr					; B0  Y     LCD
; ZberegennjaAdr			; B0   X,Y 	
; VidnovlennjaAdr			; B0  X,Y 
;
; PROBIL			; B0   -   / (6x8)
; VyvidCyfry		; B0    ,     CYFRA
; Nolx					; B0  " 0"
; Odyn					; B0  " 1"
; Dva					; B0  " 2"
; Try					; B0  " 3"
; Chotyry				; B0  " 4"
; Pjatx					; B0  " 5"
; Shistx				; B0  " 6"
; Sim					; B0  " 7"
; Visim					; B0  " 8"
; Devjatx				; B0  " 9"
;
; VyrahuvSerednxogo		; B0             
; UtochnennjaMinMax		; B0(SLR1)     
				;       w ,

; DesPeretv		; B0      
;
;!!!!!!!!	VhidnyjImpuls	; BXB0           GP2
; VymirZakincheno	; B0  
				;  , ,     
				;       
;				;    ,KONTR_REG,3 = 1,    
				;    ,     
						;     '  EEPROM
						;   RezPotVym   .
				;    99 (. )	
				;         	
; IMPULS			; B0     .
;
;!!!!!!!!	B0B1ChytatyByteEEPROM		;    EEPROM   AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
;!!!!!!!!	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
; InitEEPROM		; B0  EEPROM   
;!!!!!!!!	BXB1ZsuvEEPROM	;     EEPROM  2-  1-,  3-  2-...     
					;  2-    AdresaEEPROM, 
					; (     49 (50-1)----------------; ChytatyZ_EEPROM_DoMasyvu	;   EEPROM   (REZUL1...50+...)
;!!!!!!!!	ChytatyZ_EEPROM_DoMasyvu		; BXB0   EEPROM   (REZUL1...50)
					;B1KilxkElementiv -      EEPROM     REZULT1...50
					;         AdresaEEPROM
; VyvidZobrMasyvu			; B0    REZULT1...30...48 (   )
;!!!!!!!!	BXB0GodynVymirZakinch		;  䳿 -    
; 				1. 6        (REZULT1...REZULT_X)  EEPROM,
; 				     +1,     = 0
; 				2.  6     EEPROM
;!!!!!!!!	BXB0DobovVymirZakinch		;  䳿 -    
;
;
; 
;
;!!!!!!!!	TIMER1     ; BXB0      1
; 
;!!!!!!!!	Zatr100mks   ; BXB0   100  . . 2M
;!!!!!!!!	Zatr1ms5BXB0    ; BXB0   1,5  . . 2M


;
;
;
;
;
;---------------------------------------------------------------------------------
VyvidZobrMasyvu			; B0 (SLR3)    REZULT1...  

	MOVLW	REZULT1		; 
	MOVWF	FSR
	MOVF_F	FSR,FSR_PotStovpchyka; FSR   ( REZULT1-   - )


	CALL	Ochyshchennja		; B0     (  )

	MOVF_F	RezPotVym,SLR13	;-----------     ,   VyvidGistRezVym 
							;       .
	MOVF_F	KilxkistxVymiriv,SLR4	;=========== 30  ,     .,SLR4
	MOVF	SLR4,F
	BTFSC	STATUS,Z

	GOTO	RezultatyVidsutni

	LOADF	X_adresa,D'69'
	MOVF_F	REZULT1,PotMin		;  ., .  .. =   
	MOVF_F	REZULT1,PotMax
	MOVF_F	REZULT1,PotSerZnach
	MOVF_F	FSR_PotStovpchyka,AdresaFSR	;   REZULT1 (    )
Znovu
	CALL	Vertykalx		;    . 10,20,30
	CALL	Vst_X_Adr		; B0  X     LCD
	CLRF	Y_adresa
	CALL	Vst_Y_Adr		; B0  Y     LCD
	MOVF_F	AdresaFSR,FSR
	MOVF_F	INDF,DaniINDF	;   DaniINDF   REZULT1 (   )

	MOVF_F	DaniINDF,RezPotVym	;
	CALL	VyvidGistRezVym	; B0    


	MOVF	DaniINDF,W		;  DaniINDF   REZULT1 (   )
	CALL	UtochnennjaMinMax	;(SLR1)     
				;       w ,

	INCF	AdresaFSR,F
	DECF	X_adresa,F
	INCF	FSR_PotStovpchyka,F	; FSR   ( REZULT1-   - )


	DECFSZ	SLR4,F					;===========
	GOTO	Znovu
	CALL	VyrahuvSerednxogo		;(SLR1,SLR2,SLR3)             

	GOTO	KinVyvidZobrMasyvu
RezultatyVidsutni			;   ,  . =  = .. = 0
	CLRF	PotMin			;
	CLRF	PotMax			;
	CLRF	PotSerZnach		;
KinVyvidZobrMasyvu
	MOVF_F	SLR13,RezPotVym	;-----------     
;


	RETURN
;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------
BXB1ZsuvEEPROM	;     EEPROM  2-  1-,  3-  2-...     
			;  2-    AdresaEEPROM, 
			; (     49 (50-1)----------------
	BANK1
;------------------------------------------------------
	LOADF	B1SLR1,D'49'	;----------(50-1 = 49 -       )

Perezapys
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	DECF	EEADR,F				;   REZULT1    
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	EEADR,F		;
	INCF	EEADR,F		;	  REZULT3   

	DECFSZ	B1SLR1,F
	GOTO	Perezapys
								;     49    EEPROM
								;    REZULT50,
	DECF	EEADR,F				;    REZULT50

	MOVF_F	B1Rezultat,EEDAT
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - C

	RETURN
;---------------------------------------------------------------------------------
BXB0GodynVymirZakinch		;  䳿 -    
; 1. 6        (REZULT1...REZULT_X)  EEPROM,
;      +1,     = 0
; 2.  6     EEPROM
; 3.       
	BANK0
	DECFSZ	GodynyRobotyBatareji,F		; 93    (  24 - 00)
	GOTO	BezZminDib
	LOADF	GodynyRobotyBatareji,D'24'
	INCF	DobyRobotyBatareji,F			; 94   
	LOADF	AdresaEEPROM,0xFB	;           
	MOVF_F	DobyRobotyBatareji,DaniEEPROM			; 
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
BezZminDib
	LOADF	AdresaEEPROM,0xFC	; GodynyRobotyBatareji		; 93   
	MOVF_F	GodynyRobotyBatareji,DaniEEPROM	;     (24 - 00)
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
	CALL	  IndAkumuljatora		; B0     

	BANK1
	BCF		B1KONTR_REG2,5		;    99 (. )	
	BSF		B1KONTR_REG2,1			;       
;       2-     .
	MOVF	B1PotRezZaGodynu,W	;
	ADDWF	B1SumaDanyh2Byte0,F		; 16       2
	BTFSC	STATUS,C
	INCF	B1SumaDanyh2Byte1,F		; 17       2 

	BTFSS	B1KONTR_REG2,3		;  ,        
	GOTO	NeKraj2
;========  ʲ  ̲,     (  )
;       (50  ),   - 51-,  52-, 53-  ..  
;     EEPROM  2-  1-,  3-  2-...  B1PotRezZaGodynu  50-

; ³     REZULT1 (     ) 
;           VhidnyjImpuls Ҳ
;      2,3 '  EEPROM



	BANK1
	LOADF	EEADR,D'90'			;   REZULT1   	
								; 84   -    (  - .  = 83)
								; + 6  (B1KONTR_REG2, B1PotRezZaGodynu, B1SumaDanyh2Byte0,B1SumaDanyh2Byte1,
								; B1KilxkistxVymiriv2, B1X_adresa2( = 89))
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
								;     DaniEEPROM
	MOVF	EEDAT,W				;  REZULT1 ---> W

;         ,
	SUBWF	B1SumaDanyh2Byte0,F		;       
	BTFSS	STATUS,C				;
	DECF	B1SumaDanyh2Byte1,F		;

	MOVF	B1PotRezZaGodynu,W	;   BXB1ZsuvEEPROM    (REZULT50)  B1Rezultat
	MOVWF	B1Rezultat			;         .    .
	INCF	EEADR,F				;    REZULT2

	CALL	BXB1ZsuvEEPROM	;     EEPROM  2-  1-,  3-  2-...     
			;  2-    AdresaEEPROM, 
			; (     49 (50-1)
	GOTO	KinBXB0GodynVymirZakinch

NeKraj2			;     
	DECF	B1X_adresa2,F		;  X-    (  )
	MOVLW	D'50'
	SUBWF	B1KilxkistxVymiriv2,W
	BTFSC	STATUS,Z
	GOTO	MAX2
	INCF	B1KilxkistxVymiriv2,F
	GOTO	NORM2
MAX2
	BSF		B1KONTR_REG2,3		;   ,      
NORM2	;         
	MOVF	B1KilxkistxVymiriv2,W
	MOVWF	EEADR
	MOVLW	D'89'	; 89 -    REZULT1  EEPROM     .
	ADDWF	EEADR,F			;           
	MOVF_F	B1PotRezZaGodynu,EEDAT
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT

KinBXB0GodynVymirZakinch

	MOVF_F	B1KONTR_REG2,EEDAT
	LOADF	EEADR,D'84'
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	EEADR,F			;    .. B1PotRezZaGodynu  
	CLRF	B1PotRezZaGodynu	 ;  
	CLRF	EEDAT
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT

	INCF	EEADR,F			; 

	MOVF_F	B1SumaDanyh2Byte0,EEDAT
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	EEADR,F			;
	MOVF_F	B1SumaDanyh2Byte1,EEDAT
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	EEADR,F			;
	MOVF_F	B1KilxkistxVymiriv2,EEDAT
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
					;    BANK1,   - EEADR ,  - EEDAT
	INCF	EEADR,F			;
	MOVF_F	B1X_adresa2,EEDAT
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT


; 2.  6     EEPROM
	MOVF_F	B1KONTR_REG3,EEDAT
	LOADF	EEADR,D'140'	; 140 - ,    EEPROM   B1KONTR_REG3 (     ( )

								; ((0-83) -   + 6    (84-89) + 50    (90-139)
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	EEADR,F			;
	MOVF_F	B1PotRezZaDobu,EEDAT
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	EEADR,F			;
	MOVF_F	B1SumaDanyh3Byte0,EEDAT
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	EEADR,F			;
	MOVF_F	B1SumaDanyh3Byte1,EEDAT
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	EEADR,F			;
	MOVF_F	B1KilxkistxVymiriv3,EEDAT
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	EEADR,F			;
	MOVF_F	B1X_adresa3,EEDAT
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	BANK0
	RETURN
;---------------------------------------------------------------------------------
BXB0DobovVymirZakinch		;    
; 1.      REZULT1...REZULT_X(max=50)  EEPROM,
;      ,       EEPROM.
; 2.    = 0,    +1,   ,    = 50
; 3.   BXB0GodynVymirZakinch ,     ,   
;       EEPROM  6-       (  - ).
	BANK1
	BCF		B1KONTR_REG3,0		;    40 (. )
	BCF		B1KONTR_REG3,5		;    99 (. )	
	BSF		B1KONTR_REG3,1			;       

;       3-     .
	MOVF	B1PotRezZaDobu,W	;
	ADDWF	B1SumaDanyh3Byte0,F		; 16       3
	BTFSC	STATUS,C
	INCF	B1SumaDanyh3Byte1,F		; 17       3 

	BTFSS	B1KONTR_REG3,3		;  ,        
	GOTO	NeKraj3
;      (50  )
;     EEPROM  2-  1-,  3-  2-...  B1PotRezZaDobu  50-

	LOADF	EEADR,D'146'		;   REZULT1   	
								; 84   -    (  - .  = 83)
								; + 6  (B1KONTR_REG2, B1PotRezZaGodynu, B1SumaDanyh2Byte0,B1SumaDanyh2Byte1,
								; B1KilxkistxVymiriv2, B1X_adresa2( = 89)+50   = 139)
								; +6    = 145, 
								; , -  REZULT1    = 146
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
								;     DaniEEPROM
	MOVF	EEDAT,W		;  REZULT1 ---> W
	SUBWF	B1SumaDanyh3Byte0,F		;       
	BTFSS	STATUS,C				;
	DECF	B1SumaDanyh3Byte1,F		;

	MOVF	B1PotRezZaDobu,W
	MOVWF	B1Rezultat		;       
	INCF	EEADR,F				;    REZULT2

	CALL	BXB1ZsuvEEPROM	;     EEPROM  2-  1-,  3-  2-...     
			;  2-    AdresaEEPROM, 
			; (     49 (50-1)----------------	GOTO	KinBXB0DobovVymirZakinch
NeKraj3
	DECF	B1X_adresa3,F		;  X-    (  )
							;            " - "
	MOVLW	D'50'
	SUBWF	B1KilxkistxVymiriv3,W
	BTFSC	STATUS,Z
	GOTO	MAX3
	INCF	B1KilxkistxVymiriv3,F
	GOTO	NORM3
MAX3
	BSF		B1KONTR_REG3,3		;   ,      
NORM3
	MOVF_F	B1KilxkistxVymiriv3,EEADR

	MOVLW	D'145'	; 145 -    REZULT1  EEPROM     .
	ADDWF	EEADR,F			;           

	MOVF_F	B1PotRezZaDobu,EEDAT
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
KinBXB0DobovVymirZakinch
	LOADF	EEADR,D'141'	; 141 - ,    EEPROM   B1PotRezZaDobu 
							;(  .  )     
								; ((0-83) -   + 6    (84-89) + 50    (90-139)
	CLRF	B1PotRezZaDobu
	CLRF	EEDAT
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	BANK0
	RETURN
;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------
ChytatyZ_EEPROM_DoMasyvu		; BXB0   EEPROM   (REZUL1...50)
	;B1KilxkElementiv -      EEPROM     REZULT1...50
	;         AdresaEEPROM
	BANK1
	MOVF	B1KilxkElementiv,F	;     (=0),
	BTFSC	STATUS,Z				;    
	GOTO	KinChytannja			;
	BANK0
	MOVLW	REZULT1		;
	MOVWF	FSR
	MOVF_F	FSR,AdresaFSR
NastupneChytannja
	BANK0
	MOVF_F	AdresaFSR,FSR
	CALL	B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	MOVF_F	DaniEEPROM,INDF		;   INDF   KONTR_REG  EEPROM(   )
	INCF	AdresaFSR,F
	INCF	AdresaEEPROM,F
	BANK1
	DECFSZ	B1KilxkElementiv,F	;      EEPROM     REZULT1...30...48
	GOTO	NastupneChytannja
KinChytannja
	BANK0

	RETURN
;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------
ZminaRegymu		; BXB0       (50 ,  ,  ,  )


	CALL	Zatr1ms5BXB0    ;  1,5  . . 2M

	BTFSC	GPIO,3		; 
	GOTO	KinZminaRegymu

	BTFSS	GPIO,3		;   
	GOTO	$-1
	INCF	NomerRegymu,F

	MOVLW	D'4'			;  3  (1,2,3),  4 -  
	SUBWF	NomerRegymu,W
	BTFSS	STATUS,Z	;
	GOTO	VyznachRegymu
;; ! ! !  : 	;	BTFSC STATUS,Z
						;	LOADF	NomerRegymu,D'1'
						;     ,     ! ! !
						;
	LOADF	NomerRegymu,D'1'	
VyznachRegymu
	MOVLW	D'1'
	SUBWF	NomerRegymu,W
	BTFSS	STATUS,Z	;	
	GOTO	Regym2
;     1-  (50 )
	LOADF	X_adresa,D'15'
	CALL	Vst_X_Adr		; B0  X     LCD

	CLRF	KilxkistxVymiriv		; 30  ,     .
	CLRF	PotMin				; 23       (  )
	CLRF	PotMax				; 24       (  )
	CLRF	PotSerZnach			; 25       ( ,  )
	CLRF	KONTR_REG   	 		; 26   ,   :
	CLRF	RezPotVym			; 27   
	CLRF	SumaDanyhByte0		; 28     (  )
	CLRF	SumaDanyhByte1		; 29     (  )

	MOVLW	REZULT1		; 
	MOVWF	FSR
	MOVF_F	FSR,FSR_PotStovpchyka; FSR   ( REZULT1-   - )

	CALL	Ochyshchennja		; B0     (  )
	CALL	IndRegymu1		;      

	CALL	VyvidSerMaxMinKilxkVym		;  , ,  
;							;   

	LOADF	X_adresa,Poch_X_Adr_Gist	;  -   

	CALL	Vst_X_Adr		; B0  X     LCD
	CALL	ViknoGist		;
	CALL	VyvidRezPotVym	; B0    	RezPotVym (  ) 
							;	    

	LOADF	KilxkPeriodivT1ZaVymir,D'34'
	GOTO	KinZminaRegymu
Regym2
	MOVLW	D'2'
	SUBWF	NomerRegymu,W
	BTFSS	STATUS,Z	;		
	GOTO	Regym3
;     2-  (50  )
;  Ҳ  ,  ""      
;    EEPROM    .

	BANK1
	MOVF	B1KilxkistxVymiriv2,W
	MOVWF	B1KilxkElementiv			;      EEPROM     REZULT1...30...50		

	MOVLW	D'90'		;    REZULT1 2-  ( ) = 90
	BANK0
	MOVWF	AdresaEEPROM

	CALL	 ChytatyZ_EEPROM_DoMasyvu		; BXB0   EEPROM   (REZUL1...50)
									;         AdresaEEPROM

;   6     2-  ( )
	BANK1
	MOVF	B1KONTR_REG2,W	;
	BANK0
	MOVWF	KONTR_REG	;

	BANK1
	MOVF	B1PotRezZaGodynu,W	;
	BANK0
	MOVWF	RezPotVym	;
	BANK1
	MOVF	B1SumaDanyh2Byte0,W	;
	BANK0
	MOVWF	SumaDanyhByte0	;
	BANK1
	MOVF	B1SumaDanyh2Byte1,W	;
	BANK0
	MOVWF	SumaDanyhByte1	;

	BANK1
	MOVF	B1KilxkistxVymiriv2,W	;
	BANK0
	MOVWF	KilxkistxVymiriv	;
	BANK1
	MOVF	B1X_adresa2,W	;
	BANK0
	CALL	VyvidZobrMasyvu			;    REZULT1...50 (      )


	CALL	IndRegymu2		;      

	CALL	VyvidSerMaxMinKilxkVym		;  , ,  

	CALL	ViknoGist		;


	CALL	VyvidRezPotVym	; B0    	RezPotVym (  ) 
							;	    


	CALL	 VyvidGistRezVym	; B0     ( SLR3)
	DECF	X_adresa,F
	CALL	 VyvidGistRezVym	; B0    
	DECF	X_adresa,F
	CALL	 VyvidGistRezVym	; B0    
	DECF	X_adresa,F

	MOVLW	D'3'
	ADDWF	X_adresa,F
	CALL	Vst_X_Adr		; B0 

	GOTO	KinZminaRegymu
Regym3


	BANK1
	MOVF	B1KilxkistxVymiriv3,W
	MOVWF	B1KilxkElementiv			;      EEPROM     REZULT1...30...48		

	MOVLW	D'146'		;    REZULT1 3-  ( ) = 146
	BANK0
	MOVWF	AdresaEEPROM

	CALL	 ChytatyZ_EEPROM_DoMasyvu		; BXB0   EEPROM   (6  + REZUL1...30(48))
;   6     3-  ( )

	BANK1
	MOVF	B1KONTR_REG3,W	;
	BANK0
	MOVWF	KONTR_REG	;

	BANK1
	MOVF	B1PotRezZaDobu,W	;
	BANK0
	MOVWF	RezPotVym	;
	BANK1
	MOVF	B1SumaDanyh3Byte0,W	;
	BANK0
	MOVWF	SumaDanyhByte0	;
	BANK1
	MOVF	B1SumaDanyh3Byte1,W	;
	BANK0
	MOVWF	SumaDanyhByte1	;

	BANK1
	MOVF	B1KilxkistxVymiriv3,W	;
	BANK0
	MOVWF	KilxkistxVymiriv	;
	BANK1
	MOVF	B1X_adresa3,W	;
	BANK0
	MOVWF	X_adresa	;

	CALL	VyvidZobrMasyvu			;    REZULT1...30...48 (   )

	CALL	IndRegymu3		;      

	CALL	VyvidSerMaxMinKilxkVym		;  , ,  
;							;   


	CALL	ViknoGist		;
	CALL	VyvidRezPotVym	; B0    	RezPotVym (  ) 
							;	    


;        
	CALL	 VyvidGistRezVym	; B0    
	DECF	X_adresa,F
	CALL	 VyvidGistRezVym	; B0    
	DECF	X_adresa,F
	CALL	 VyvidGistRezVym	; B0    
	DECF	X_adresa,F
;
	MOVLW	D'3'
	ADDWF	X_adresa,F
	CALL	Vst_X_Adr		; B0 

	GOTO	KinZminaRegymu


KinZminaRegymu	

	CALL	IndAkumuljatora		; B0     

	RETURN
;---------------------------------------------------------------------------------
IndRegymu1		; B0  1:"- - "   
	CALL	ZberegennjaAdr		;   X,Y 		
	CLRF	FSR
	CLRF	X_adresa			;5       LCD
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'2'			; Y      LCD
	CALL	Vst_Y_Adr		; B0 

STR1_1	MOVLW	(Reg1Str1Tbl>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	CALL	Reg1Str1Tbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
 ;						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	STR1_1_Kin
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	STR1_1
STR1_1_Kin
	CLRF	X_adresa			;5       LCD
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'1'			; Y      LCD
	CALL	Vst_Y_Adr		; B0 

	CLRF	FSR
STR1_2	MOVLW	(Reg1Str2Tbl	>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	CALL	Reg1Str2Tbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
;						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	STR1_2_Kin
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	STR1_2
STR1_2_Kin
	CLRF	X_adresa			;5       LCD
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'0'			; Y      LCD
	CALL	Vst_Y_Adr		; B0 

	CLRF	FSR
;STR1_3	MOVLW	(Reg1Str3Tbl	>>8)	;set PCLATH to the high order address
;	MOVWF	PCLATH		;of the table (bits 12:8)
;	MOVF	FSR,W		;current index
;	INCF	FSR,F		;next
;	CALL	Reg1Str3Tbl		;get current character
;	MOVWF	SLR7			;  W
;	LOADF	SLR5,StopByte	;  ,           (B'10101010')
;;						;           
;	MOVF	SLR7,W		;  W
;	SUBWF	SLR5,F
;	BTFSC	STATUS,Z
;	GOTO	STR1_3_Kin
;	MOVWF	PerByte
;	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
;	GOTO	STR1_3
;STR1_3_Kin

	CALL	VidnovlennjaAdr		;  X,Y 
	RETURN
;---------------------------------------------------------------------------------
IndRegymu2		; B0  2:"- "   
	CALL	ZberegennjaAdr		;   X,Y 		
	CLRF	FSR
	CLRF	X_adresa			;5       LCD
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'2'			; Y      LCD
	CALL	Vst_Y_Adr		; B0 


STR2_1	MOVLW	(Reg2Str1Tbl>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	CALL	Reg2Str1Tbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
 ;;						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	STR2_1_Kin
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	STR2_1
STR2_1_Kin
	CLRF	X_adresa			;5       LCD
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'1'			; Y      LCD
	CALL	Vst_Y_Adr		; B0 
;
	CLRF	FSR
STR2_2	MOVLW	(Reg2Str2Tbl	>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	CALL	Reg2Str2Tbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
;						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	STR2_2_Kin
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	STR2_2
STR2_2_Kin
	CLRF	X_adresa			;5       LCD
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'0'			; Y      LCD
	CALL	Vst_Y_Adr		; B0 

	LOADF	SLR5,D'14'
	CLRF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	DECFSZ	SLR5,F
	GOTO	$-3

	CALL	VidnovlennjaAdr		;  X,Y 
	RETURN
;---------------------------------------------------------------------------------
IndRegymu3		; B0  3:""         

	CALL	ZberegennjaAdr		;   X,Y 		
	CLRF	FSR
	CLRF	X_adresa			;5       LCD
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'2'			; Y      LCD
	CALL	Vst_Y_Adr		; B0 


STR3_1	MOVLW	(Reg3Str1Tbl>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	CALL	Reg3Str1Tbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	STR3_1_Kin
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	STR3_1
STR3_1_Kin
	CLRF	X_adresa			;5       LCD
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'1'			; Y      LCD
	CALL	Vst_Y_Adr		; B0 

	LOADF	SLR5,D'14'
	CLRF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	DECFSZ	SLR5,F
	GOTO	$-3

	CLRF	X_adresa			;5       LCD
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'0'			; Y      LCD
	CALL	Vst_Y_Adr		; B0 

	LOADF	SLR5,D'14'
	CLRF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	DECFSZ	SLR5,F
	GOTO	$-3

	CALL	VidnovlennjaAdr		;  X,Y 
	RETURN
;---------------------------------------------------------------------------------
IndAkumuljatora		; B0     
	CALL	ZberegennjaAdr	;   X,Y 	

	CLRF	X_adresa			;5       LCD
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'4'			; Y      LCD
	CALL	Vst_Y_Adr		; B0 

	LOADF	PerByte,B'10011100'
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	LOADF	PerByte,B'10111110'
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	LOADF	SLRIndykaciji,D'8'	;=========

	MOVF_F	OdnaVosxmaTermBatDib,SLR11
		; 92        
Prodovgyty
	MOVF	SLR11,W
	SUBWF	DobyRobotyBatareji,W
	BTFSC	STATUS,C		; C=0 ,   ,     
	GOTO	ROZRJADGENO		;
	LOADF	PerByte,B'10111110'	;
	GOTO	ZARJADJENO		;
ROZRJADGENO					;
	LOADF	PerByte,B'10100010'	;
ZARJADJENO	;
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	MOVF	OdnaVosxmaTermBatDib,W
	ADDWF	SLR11,F			;         2/8     
	DECFSZ	SLRIndykaciji,F		;==========
	GOTO	Prodovgyty

	LOADF	PerByte,B'10111110'
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510

	CALL	VidnovlennjaAdr	;  X,Y 

	RETURN
;---------------------------------------------------------------------------------
IndKilxkVymiriv		; B0       	

	
	CLRF	X_adresa			;5       LCD
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'3'			; Y      LCD
	CALL	Vst_Y_Adr		; B0 

	MOVF_F	KilxkistxVymiriv,ByteChisla
	CALL	DesPeretv		;      

	MOVF_F	Znach1,Cyfra
	CALL	VyvidCyfry

	MOVF	Znach10,F
	BTFSC	STATUS,Z		; Z=0 -   
	GOTO 	Bez10_K


	MOVF_F	Znach10,Cyfra
	CALL	VyvidCyfry
	GOTO 	Dali1_K
Bez10_K
	CALL	PROBIL		;   -   / (6x8)
Dali1_K


	RETURN
;---------------------------------------------------------------------------------
InitEEPROM		; B0  EEPROM   
;    
	LOADF	AdresaEEPROM,0xFC	; GodynyRobotyBatareji		; 93   
	LOADF	DaniEEPROM,D'24'	;     (24 - 00)
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM

	LOADF	AdresaEEPROM,0xFB	;           
	CLRF	DaniEEPROM			;     
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	BTFSC	KONTR_REG,6		;       
							; 1 -     
	GOTO	KinInitEEPROM
;  2- 
	MOVLW	D'84'			;  B1KONTR_REG2
	MOVWF	AdresaEEPROM

	CLRF	DaniEEPROM	;
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	AdresaEEPROM,F	;  B1PotRezZaGodynu
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	AdresaEEPROM,F	;  B1SumaDanyh2Byte0
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	AdresaEEPROM,F	;  B1SumaDanyh2Byte1
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	AdresaEEPROM,F	;  B1KilxkistxVymiriv2
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	AdresaEEPROM,F	;  B1X_adresa22
	LOADF	DaniEEPROM,D'69'
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
;  3- 
	LOADF	AdresaEEPROM,D'140'			;  B1KONTR_REG3
	CLRF	DaniEEPROM	;
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	AdresaEEPROM,F	;  B1PotRezZaDobu
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	AdresaEEPROM,F	;  B1SumaDanyh3Byte0
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	AdresaEEPROM,F	;  B1SumaDanyh3Byte1
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	AdresaEEPROM,F	;  B1KilxkistxVymiriv3
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	INCF	AdresaEEPROM,F	;  B1X_adresa3
	LOADF	DaniEEPROM,D'69'
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT



	BTFSC	KONTR_REG,4		;      
							; (         
							;      ,  -20, 
	GOTO	KinInitEEPROM

	LOADF	AdresaEEPROM,0xFF
								;          1
	LOADF	DaniEEPROM,D'34'		;  (   2/   1:8   .    
								;  1 = 1 .	)
								; 1  34 = 34,   .    -20 (34,3 )
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT

	LOADF	AdresaEEPROM,0xFE
							;            

	LOADF	DaniEEPROM,D'106'	;  3600 / 34 =  106
							; 
							; 34 -  .    -20

	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT



	LOADF	AdresaEEPROM,0xFD	;            


	LOADF	DaniEEPROM,D'49'		;  2,405 /3,7 = 650 *
								;  0,55, =650*/0,55 = .1182 =/24 = .49.
	CALL	B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT

KinInitEEPROM

	RETURN
;---------------------------------------------------------------------------------
B0B1ChytatyByteEEPROM		;    EEPROM   B1AdresaEEPROM,     DaniEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	BTFSS	STATUS,RP0	; ,    
	GOTO	B0			;   "  0- "
	BANK0
	BSF		KONTR_REG,7	;   7- 0/1 - Ͳ /  - 
						;     1-       EEPROM
	BANK1
	GOTO	B1
B0
	MOVF	AdresaEEPROM,W		;	
	BANK1         ;   1
	MOVWF		EEADR 
B1
	MOVF	INTCON,W
	MOVWF	B1Intcon_TEMP		;  INTCON       GIE (7)
	BCF		INTCON,GIE	;   
	BSF        EECON1, RD            ; 
	MOVF		EEDAT,W    ;     W
	BANK0         ;   0
	MOVWF		DaniEEPROM		; ( ,    )
	BANK1
	BTFSC	B1Intcon_TEMP	,7		;        INTCON,GIE=0 ( )    
	BSF		INTCON,GIE	;    
	BANK0
	BTFSS	KONTR_REG,7	; 
	GOTO	KinB0B1ChytatyByteEEPROM	;    +    0
	BCF		KONTR_REG,7	;   7- 0/1 - Ͳ /  - 
						;     1-       EEPROM
	BANK1	;  +    1
KinB0B1ChytatyByteEEPROM
	RETURN
;---------------------------------------------------------------------------------
B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
						;    BANK1,   - EEADR ,  - EEDAT
	BTFSS	STATUS,RP0	; ,    
	GOTO	B0Z			;   "  0- "
;9999999999
	BANK0
	BSF		KONTR_REG,7	;   7- 0/1 - Ͳ /  - 
						;     1-       EEPROM
	BANK1
	GOTO	B1Z
B0Z
	BANK0			; ʲ Ѳ ײ ò   ² "0"
	MOVFW	AdresaEEPROM		;	
	BANK1         ;   1
	MOVWF		EEADR 
	BANK0         ;   0
	MOVFW	DaniEEPROM	;	
	BANK1         ;   1
	MOVWF		EEDAT 
B1Z
	MOVF	INTCON,W
	MOVWF	B1Intcon_TEMP		;  INTCON       GIE (7)
; '   =========================
	BSF		EECON1,WREN	;  	
	BCF		INTCON,GIE	;   
	BTFSC	INTCON,GIE
	GOTO	$-2
	MOVLW	0x55			;  
	MOVWF	EECON2		;
	MOVLW	0xAA			;
	MOVWF	EECON2		;
	BSF		EECON1,WR	;  
;============================================================
ChekatyZakinchZapysu
	BTFSC	EECON1,WR
	GOTO	ChekatyZakinchZapysu

	BTFSC	B1Intcon_TEMP	,7		;        INTCON,GIE=0 ( )    
	BSF		INTCON,GIE	;    
	BANK0
	BTFSC	KONTR_REG,7	; 7- 0/1 - Ͳ /  -     1-       EEPROM
	GOTO	ZalyshB1Z
	GOTO	ZalyshB0Z
ZalyshB1Z	;   1
	BCF		KONTR_REG,7	;   7- 0/1 - Ͳ /  - 
						;     1-       EEPROM
	BANK1
ZalyshB0Z	;   0

	RETURN

;B0B1ZapysatyByteEEPROM		;   EEPROM    DaniEEPROM   AdresaEEPROM
;						;    BANK1,   - EEADR ,  - EEDAT
;	BTFSS	STATUS,RP0	; ,    
;	GOTO	B0Z			;   "  0- "
;	BSF		KONTR_REG,7	;   7- 0/1 - Ͳ /  - 
;						;     1-       EEPROM
;	GOTO	B1Z
;B0Z
;	BANK0			; ʲ Ѳ ײ ò   ² "0"
;	MOVFW	AdresaEEPROM		;	
;	BANK1         ;   1
;	MOVWF		EEADR 
;	BANK0         ;   0
;	MOVFW	DaniEEPROM	;	
;	BANK1         ;   1
;	MOVWF		EEDAT 
;	MOVF	INTCON,W
;	MOVWF	B1Intcon_TEMP		;  INTCON       GIE (7)
;; '   =========================
;	BSF		EECON1,WREN	;  	
;	BCF		INTCON,GIE	;   
;	BTFSC	INTCON,GIE
;	GOTO	$-2
;	MOVLW	0x55			;  
;	MOVWF	EECON2		;
;	MOVLW	0xAA			;
;	MOVWF	EECON2		;
;	BSF		EECON1,WR	;  
;;============================================================
;ChekatyZakinchZapysu
;	BTFSC	EECON1,WR
;	GOTO	ChekatyZakinchZapysu
;	BTFSC	B1Intcon_TEMP	,7		;        INTCON,GIE=0 ( )    
;	BSF		INTCON,GIE	;    
;	BANK0
;	BCF		KONTR_REG,7	;   7- 0/1 - Ͳ /  - 
;						;     1-       EEPROM
;	GOTO	KinB0B1ZapysatyByteEEPROM
;
;B1Z
;	MOVF	INTCON,W
;	MOVWF	B1Intcon_TEMP		;  INTCON       GIE (7)
;; '   =========================
;	BSF		EECON1,WREN	;  	
;	BCF		INTCON,GIE	;   
;	BTFSC	INTCON,GIE
;	GOTO	$-2
;	MOVLW	0x55			;  
;	MOVWF	EECON2		;
;	MOVLW	0xAA			;
;	MOVWF	EECON2		;
;	BSF		EECON1,WR	;  
;
;;============================================================
;ChekatyZakinchZapysuB1
;	BTFSC	EECON1,WR
;	GOTO	ChekatyZakinchZapysuB1
;	BTFSC	B1Intcon_TEMP	,7		;        INTCON,GIE=0 ( )    
;	BSF		INTCON,GIE	;    
;	BANK0
;	BCF		KONTR_REG,7	;   7- 0/1 - Ͳ /  - 
;						;     1-       EEPROM
;	BANK1
;KinB0B1ZapysatyByteEEPROM
;	RETURN
;---------------------------------------------------------------------------------
;****************
; ²  LCD
;****************
Vst_X_Adr		; B0  X     LCD
	MOVLW	B'10000000'		;    X (1 X6 X5 X4 X3 X2 X1 X0)
	ADDWF	X_adresa,W	;
	MOVWF	PerByte	;   W     
	CALL	PER_BYTE_COM	; B0   -  PIC12F683  LCD Nokia 5510
	RETURN
;---------------------------------------------------------------------------------
Vst_Y_Adr		; B0  Y     LCD
	MOVLW	B'01000000'		;    Y (01000 Y2 Y1 Y0)
	ADDWF	Y_adresa,W	;
	MOVWF	PerByte	;   W     
	CALL	PER_BYTE_COM	; B0   -  PIC12F683  LCD Nokia 5510
	RETURN
;---------------------------------------------------------------------------------
ZberegennjaAdr		; B0   X,Y 					
	MOVF_F	X_adresa,X_Adr_Zbereg		;  X-      	
	MOVF_F	Y_adresa,Y_Adr_Zbereg		;  Y-      	
	RETURN
;---------------------------------------------------------------------------------
VidnovlennjaAdr		; B0  X,Y 
	MOVF_F	X_Adr_Zbereg,X_adresa		;  X-
	CALL	Vst_X_Adr		; B0  X     LCD
	MOVF_F	Y_Adr_Zbereg,Y_adresa		;  Y-
	CALL	Vst_Y_Adr		; B0  X     LCD
	RETURN
;-------------------------------------------------------------------------------
INIT_LCD     ; B0  LCD
	CALL	RESET
	MOVLW	B'00100001'   ;     
	MOVWF	PerByte	;   W     
	CALL	PER_BYTE_COM	; B0   -  PIC12F683  LCD Nokia 5510
	MOVLW	B'11000000'   ;   LCD 5  (  LCD)
	MOVWF	PerByte	;   W     
	CALL	PER_BYTE_COM	; B0   -  PIC12F683  LCD Nokia 5510
	MOVLW	B'00000111'   ;   
	MOVWF	PerByte	;   W     
	CALL	PER_BYTE_COM	; B0   -  PIC12F683  LCD Nokia 5510
	MOVLW	B'00010011'   ;    . 1:48
	MOVWF	PerByte	;   W     
	CALL	PER_BYTE_COM	; B0   -  PIC12F683  LCD Nokia 5510
	MOVLW	B'00100000'   ;         X-
	MOVWF	PerByte	;   W     
	CALL	PER_BYTE_COM	; B0   -  PIC12F683  LCD Nokia 5510

	MOVLW	B'00001100'   ;     
                          ;B'00001D0E'
                          ;DE : "00" - BLANK, "10" - NORMAL,
                          ;     "01" - all position ON,"11" - inverse
;	MOVLW	B'00001101'  ;  

	MOVWF	PerByte	;   W     
	CALL	PER_BYTE_COM	; B0   -  PIC12F683  LCD Nokia 5510

	RETURN
;---------------------------------------------------------------------------------
PER_BYTE_COM	; B0   -  PIC12F683  LCD Nokia 5510
			;     PerByte
	BCF		DatCom   ; 0 -   .
					;   LCD-    
					;   ,     .
;	CALL 	PER_BYTE		;     PIC12F683  LCD Nokia 5510
			;     "W"
;---------------------------------------------------------------------------------
;  -   Ͳ 2
;---------------------------------------------------------------------------------
			;     PIC12F683  LCD Nokia 5510
			;     PerByte
	MOVLW	0x08
	MOVWF	NomerBita	;      
	BCF		ClockLine
NewBitCOM
	BTFSC	PerByte,7
	BSF		DataLine
	BTFSS	PerByte,7
	BCF		DataLine
	BSF		ClockLine
	BCF		ClockLine
	RLF		PerByte,F   ;
	DECFSZ	NomerBita,F   ;
	GOTO	NewBitCOM
	
	BCF		DataLine		;   ,      ̲ ײ ! ! !
	RETURN
;---------------------------------------------------------------------------------
PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
			;     PerByte
	BSF		DatCom   ; 1 -   .
					;   LCD-    
					;   ,     .
;	CALL 	PER_BYTE		;     PIC12F683  LCD Nokia 5510
		
;---------------------------------------------------------------------------------
;  -   Ͳ 2
;---------------------------------------------------------------------------------
		;     PIC12F683  LCD Nokia 5510
			;     PerByte
	MOVLW	0x08
	MOVWF	NomerBita	;      
	BCF		ClockLine
NewBitDATA
	BTFSC	PerByte,7
	BSF		DataLine
	BTFSS	PerByte,7
	BCF		DataLine
	BSF		ClockLine
	BCF		ClockLine
	RLF		PerByte,F   ;
	DECFSZ	NomerBita,F   ;
	GOTO	NewBitDATA
	
	BCF		DataLine		;   ,      ̲ ײ ! ! !


	RETURN
;---------------------------------------------------------------------------------
;Ͳ ϲ  ߪ   ϲ ! ! !  -   Ͳ 2
;---------------------------------------------------------------------------------
;PER_BYTE		;     PIC12F683  LCD Nokia 5510
;			;     PerByte
;	MOVLW	0x08
;	MOVWF	NomerBita	;      
;	BCF		ClockLine
;NewBitCM
;	BTFSC	PerByte,7
;	BSF		DataLine
;	BTFSS	PerByte,7
;	BCF		DataLine
;	BSF		ClockLine
;	BCF		ClockLine
;	RLF		PerByte,F   ;
;	DECFSZ	NomerBita,F   ;
;	GOTO	NewBitCM
;	
;	BCF		DataLine		;   ,      ̲ ײ ! ! !
;	RETURN
;---------------------------------------------------------------------------------
RESET		; B0     LCD
	BCF	ResetLCD

;	CALL	Zatr100mks   ;  100  . . 2M
	CALL	Zatr1ms5BXB0    ;  1,5  . . 2M
	BSF	ResetLCD
	RETURN
;*********************
; 1.² ò
;*********************
;---------------------------------------------------------------------------------

PotochnaZmina		; B0    RezPotVym
			; +    (RezPotVym)  + 
			; +     40(.)  99(. )
			;    KONTR_REG,5  
	BTFSC	KONTR_REG,5	;        "99"
	GOTO	KinPotochnaZmina	; 
	INCF	RezPotVym,F	;    

	MOVLW	D'99'		;    = 99
	SUBWF	RezPotVym,W	;  " ",         2-    
	BTFSC	STATUS,Z	;
	BSF		KONTR_REG,5	; " "

;    	RezPotVym (  )     

	CALL	VyvidRezPotVym	; B0    	RezPotVym (  ) 
							;	    


;     
	CALL	 VyvidGistRezVym	; B0    
	DECF	X_adresa,F
	CALL	 VyvidGistRezVym	; B0    
	DECF	X_adresa,F
	CALL	 VyvidGistRezVym	; B0    
	DECF	X_adresa,F
	MOVLW	D'3'
	ADDWF	X_adresa,F
	CALL	Vst_X_Adr		; B0 
KinPotochnaZmina

	RETURN
;-------------------------------------------------------------------------------
VyvidRezPotVym	; B0    	RezPotVym (  )
				;     
	MOVLW	D'17'
	SUBWF	X_adresa,F	;
	CALL	Vst_X_Adr		; B0 
	MOVF_F	RezPotVym,ByteChisla
	CALL	DesPeretv		;      
	MOVF_F	Znach1,Cyfra
	CALL	VyvidCyfry
	MOVF	Znach10,F
	BTFSC	STATUS,Z		; Z=0 -   
	GOTO 	BezDesjatkiv
	MOVF_F	Znach10,Cyfra
	CALL	VyvidCyfry
	GOTO 	VidnovlennjaPozyciji
BezDesjatkiv
	CALL	PROBIL		;   -   / (6x8)
VidnovlennjaPozyciji
	MOVLW	D'17'
	ADDWF	X_adresa,F
	CALL	Vst_X_Adr		; B0 
	RETURN
;-------------------------------------------------------------------------------
ZbilxshSumy0_ZOBR		; B0    ,     
						;     '  EEPROM
						;   RezPotVym   .
	MOVF	RezPotVym,W
	ADDWF	SumaDanyhByte0,F	;    
	BTFSC	STATUS,C
	INCF	SumaDanyhByte1,F	;    	

	RETURN
;---------------------------------------------------------------------------------
VyvidGistRezVym	; B0      ,   RezPotVym -   
				;     Vertykalx ,      

;  RezPotVym=0,    
	MOVF	RezPotVym,F
	BTFSC	STATUS,Z			; 0/1 -    /  ;0/1 -    /
	GOTO 	VSE
; ,    40    40
	MOVLW	D'40'
	SUBWF	RezPotVym,W
	BTFSS	STATUS,C		; C=1 -->   RezPotVym >=40
	GOTO	Menshe41
	LOADF	StovpchykGistogramy,D'40'			; 95   ( 0  40)
	GOTO	Vyvid40	
Menshe41
	MOVF_F	RezPotVym,StovpchykGistogramy			; 95   ( 0  40)
Vyvid40
;   
	CALL	Vst_X_Adr		; B0  X     LCD
	CLRF	Y_adresa
	CALL	Vst_Y_Adr		; B0  Y     LCD
	CLRF	GistByte
;	MOVF_F	StovpchykGistogramy,SLR3	;     SLR3     
ZbilxshytyStovpchyk
	MOVLW	B'00000001'
	ADDWF	GistByte,F
	DECFSZ	StovpchykGistogramy,F	;     
	GOTO	PerevirkaByte
	GOTO	KincevyjVyvid	
PerevirkaByte
;   = 11111111,     , 
;     ,  Y_adresa  
	BCF		STATUS,C	
	RLF		GistByte,F		;
	BTFSC	STATUS,C		; C=0/1 -    /
	GOTO	PromignyjVyvid
	GOTO	ZbilxshytyStovpchyk

PromignyjVyvid
	LOADF 	PerByte,0xFF
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	INCF	Y_adresa,F
	CALL	Vst_Y_Adr		; B0  Y     LCD
	CALL	Vst_X_Adr		; B0  X     LCD
	CLRF	GistByte
	GOTO	ZbilxshytyStovpchyk
KincevyjVyvid
	MOVF_F	GistByte,PerByte	
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510

VSE
	CLRF	Y_adresa
	CALL	Vst_X_Adr		; B0   X     LCD
	CALL	Vst_Y_Adr		; B0  Y     LCD
;	CALL	VyvidRezPotVym	; B0    	RezPotVym (  ) 
							;	    

	RETURN
;---------------------------------------------------------------------------------
ZsuvGrafika				; B0       
;             (REZULT1)
;     REZULT50      RezPotVym.
;       ,    
;
	CALL	ZberegennjaAdr		;   X,Y 	

	MOVF_F	RezPotVym,SLR12		;    
	MOVF_F	RezPotVym,PotMin		;      
	MOVF_F	RezPotVym,PotMax		;    ,      
	
	LOADF	X_adresa,Poch_X_Adr_Gist	;  -   
	CALL	Vst_X_Adr		; B0  X     LCD

	MOVF	REZULT1,W			;         ,
	SUBWF	SumaDanyhByte0,F		;       
	BTFSS	STATUS,C				;
	DECF	SumaDanyhByte1,F		;


	LOADF	SLR11,D'49'	;    - 1, 
						;   49     50-   49-  (REZULT49)
						;       50  (REZULT50) ----------------------------------
	MOVLW	REZULT2		; 
	MOVWF	FSR
	MOVF_F	FSR,AdresaFSR
ShcheRaz
	MOVF_F	AdresaFSR,FSR
	MOVF_F	INDF,DaniINDF	;   DaniINDF   REZULT2 (   )

	MOVF	DaniINDF	,W		;     
	SUBWF	PotMin,W			;
	BTFSS	STATUS,C		; =1 - ,   (=),    (=)  	
	GOTO	PerevMax
	MOVF_F	DaniINDF,PotMin	;
PerevMax
	MOVF	DaniINDF,W		;     
	SUBWF	PotMax,W			;
	BTFSC	STATUS,C		; =1 - ,   ,      	
	GOTO	Dali
	MOVF_F	DaniINDF,PotMax		;

Dali
	DECF	AdresaFSR,F		;       REZULT1 (   )
	MOVF_F	AdresaFSR,FSR
	MOVF_F	DaniINDF,INDF	;    REZULT2  REZULT1 (   )

	CALL	Vertykalx ;     KONTR_IND_REG -   .,     
	MOVF_F	DaniINDF,RezPotVym
	CALL	VyvidGistRezVym	; B0    
	DECF	X_adresa,F	;      
	CALL	Vst_X_Adr		; B0  X     LCD

	INCF	AdresaFSR,F
	INCF	AdresaFSR,F		;   REZULT3 (   )
								; 48    REZULT50    
								;   ( REZULT50  REZULT49)
							;  49-     
							;  ϲ REZULT50  ( SLR1)
	DECFSZ	SLR11,F		; ,     ---------------------------
	GOTO	ShcheRaz

	MOVF_F	SLR12,RezPotVym		;  RezPotVym
	DECF	AdresaFSR,F		;   REZULT50	
	MOVF_F	AdresaFSR,FSR
	MOVF_F	RezPotVym,INDF	;    RezPotVym    REZULT 

	LOADF	KilxkistxVymiriv,D'50'		
	CALL	VyrahuvSerednxogo		;         
								;    
	CALL	VyvidGistRezVym	; B0  50-   (RezPotVym = REZULT50) 
	CALL	VidnovlennjaAdr		;  X,Y 
	RETURN
;---------------------------------------------------------------------------------
ZsuvViknaTaGistogramy		; B0       
;					;    ,KONTR_REG,3 = 1,    
	BTFSS	KONTR_REG,3
	GOTO	NeKraj
;  ,    Ͳ ² 

;        
;       
	MOVLW	D'2'			; ̲
	ADDWF	X_adresa,F	;	;  ! ! !
	CALL	Vst_X_Adr		; B0  X     LCD	

	CALL	ViknoGist		;     (  )	
	CALL	ZsuvGrafika				; B0       

	GOTO	KinZsuvViknaTaGistogramy

NeKraj		;       
	MOVLW	D'2'
	ADDWF	X_adresa,F	;
	CALL	Vertykalx ;     KONTR_REG,4  7 -   .,     
	CALL	VyvidGistRezVym	; B0    
	DECF	X_adresa,F	;

	CALL	ViknoGist		;    



KinZsuvViknaTaGistogramy

	RETURN
;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------
ViknoGist		; B0    
			;  ,  ,    ,  
	BSF		KONTR_IND_REG,3	;          
	CALL	Vertykalx ;     KONTR_IND_REG -   .,     
	DECF	X_adresa,F	
	BSF		KONTR_IND_REG,1	;      
	CALL	Vertykalx		;      
	DECF	X_adresa,F
	BSF		KONTR_IND_REG,2	; Ҳ ²    (  ) 
	CALL	Vertykalx ;     KONTR_IND_REG -   .,     
	DECF	X_adresa,F
	BSF		KONTR_IND_REG,2	; Ҳ ²    (  ) 
	CALL	Vertykalx ;     KONTR_REG,4  7 -   .,     
	DECF	X_adresa,F
	BSF		KONTR_IND_REG,2	; Ҳ ²    (  ) 
	CALL	Vertykalx ;     KONTR_IND_REG -   .,     
	DECF	X_adresa,F
	BSF		KONTR_IND_REG,1	;      
	CALL	Vertykalx		;      	

;777777777
;	CALL	VyvidRezPotVym	; B0    	RezPotVym (  ) 
							;	    


	MOVLW	D'3'
	ADDWF	X_adresa,F	;
	CLRF	Y_adresa
	CALL	Vst_X_Adr		; B0  X     LCD
	CALL	Vst_Y_Adr		; B0  Y     LCD


  RETURN
;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------
;*********************
; 2.² 
;*********************
Vertykalx ; B0     KONTR_IND_REG,1,2  3 -  , .  
			; KONTR_IND_REG,1 = 1 -  
			; KONTR_IND_REG,2 = 1 -   
			; KONTR_IND_REG,3 = 1 -   (     )
			; KONTR_IND_REG,10 = 0 -  
	CLRF	Y_adresa
	CALL	Vst_Y_Adr		; B0 
	CALL	Vst_X_Adr		; B0 
	BTFSC	KONTR_IND_REG,2	; 2- 0/1 -  ² Ҳ / Ҳ ²    
							; (     )
				;     ,       
				;      .
	GOTO	BezGodynnyhPoznachok

;   2 -  , 
;;  ί   (24 , 48    ,  67  43 - )
	MOVLW	D'2'
	SUBWF	NomerRegymu,W
	BTFSS	STATUS,Z
	GOTO	BezGodynnyhPoznachok
	MOVLW	D'43'
	SUBWF	X_adresa,W
	BTFSS	STATUS,Z
	GOTO	PerevDrugojiAdresy
	LOADF	SLRIndykaciji,D'5'	
	GOTO	Punktyr
PerevDrugojiAdresy
	MOVLW	D'67'
	SUBWF	X_adresa,W
	BTFSS	STATUS,Z
	GOTO	BezGodynnyhPoznachok
	LOADF	SLRIndykaciji,D'5'	
	GOTO	Punktyr
BezGodynnyhPoznachok
	MOVLW	B'00000011'
	ANDWF	KONTR_IND_REG,W	;  KONTR_IND_REG(1-  0- ) ,    
	BTFSC	STATUS,Z			;     ,  . ,
	GOTO	Ochystka			;     
;  -   
	LOADF	SLRIndykaciji,D'5'	;-------   ,   ,    
	BTFSC	KONTR_IND_REG,0	; 1 -  ֲί  
	MOVLW	0xFF
	BTFSC	KONTR_IND_REG,1	; 1 -  ί  
Punktyr
	MOVLW	B'10101010'
	MOVWF	ByteIndykaciji		; 14   (    )
Povtoryty
	MOVF_F	ByteIndykaciji,PerByte		;  ,    PerByte   
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	INCF	Y_adresa,F
	CALL	Vst_Y_Adr		; B0 
	CALL	Vst_X_Adr		; B0 
	DECFSZ	SLRIndykaciji,F		;--------
	GOTO	Povtoryty
	GOTO	KinVertykalx		; ղ
Ochystka		;       ,  . , 
			;     
			;     Y_adresa=0
	BTFSC	X_adresa,0	;  
	GOTO	PROMIGOK1
	BTFSS	X_adresa,0	;    
	MOVLW	B'00000001'	;     -   ()
	MOVWF	PerByte
	GOTO	RYSKA1
PROMIGOK1
	CLRF	PerByte
RYSKA1
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510

	INCF	Y_adresa,F
	CALL	Vst_Y_Adr		; B0 
	CALL	Vst_X_Adr		; B0    X,      1- 
	BTFSC	KONTR_IND_REG,2	; 2- 0/1 -  ² Ҳ / Ҳ ²    
							; (     )
	GOTO	VidobragatyShkalu10
	BTFSC	KONTR_IND_REG,3	; 3- 0/1 -   /   (     )
	GOTO	PROMIGOK2
	BTFSC	X_adresa,1	;  
	GOTO	PROMIGOK2
VidobragatyShkalu10
	LOADF	PerByte,B'00000010'
	GOTO	RYSKA2
PROMIGOK2
	CLRF	PerByte
RYSKA2
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510

	INCF	Y_adresa,F
	CALL	Vst_Y_Adr		; B0 
	CALL	Vst_X_Adr		; B0    X,      1- 
	BTFSC	KONTR_IND_REG,2	; 2- 0/1 -  ² Ҳ / Ҳ ²    
							; (     )
	GOTO	VidobragatyShkalu20
	BTFSC	KONTR_IND_REG,3	; 3- 0/1 -   /   (     )
	GOTO	PROMIGOK3
	BTFSC	X_adresa,2	;  
	GOTO	PROMIGOK3
	BTFSS	X_adresa,2	;  
VidobragatyShkalu20
	LOADF	PerByte,B'00001000'
	GOTO	RYSKA3
PROMIGOK3
	CLRF	PerByte
RYSKA3
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510

	INCF	Y_adresa,F
	CALL	Vst_Y_Adr		; B0 
	CALL	Vst_X_Adr		; B0    X,      1- 
	BTFSC	KONTR_IND_REG,2	; 2- 0/1 -  ² Ҳ / Ҳ ²    
							; (     )
	GOTO	VidobragatyShkalu30
	BTFSC	KONTR_IND_REG,3	; 3- 0/1 -   /   (     )
	GOTO	PROMIGOK4
	BTFSC	X_adresa,3	;  
	GOTO	PROMIGOK4
	BTFSS	X_adresa,3	;  
VidobragatyShkalu30
	LOADF	PerByte,B'00100000'
	GOTO	RYSKA4
PROMIGOK4
	CLRF	PerByte
RYSKA4
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510

	INCF	Y_adresa,F
	CALL	Vst_Y_Adr		; B0 
	CALL	Vst_X_Adr		; B0    X,      1- 
;    -------------------------
	MOVLW	D'20'
	SUBWF	X_adresa,W
	BTFSS	STATUS,Z
	GOTO	NastupnaPerevirka11	
	MOVLW	B'10101010'
	GOTO	KinPerevirok
NastupnaPerevirka11	
	MOVLW	D'30'
	SUBWF	X_adresa,W
	BTFSS	STATUS,Z
	GOTO	NastupnaPerevirka21	
	MOVLW	B'10101010'
	GOTO	KinPerevirok
NastupnaPerevirka21	
	MOVLW	D'40'
	SUBWF	X_adresa,W
	BTFSS	STATUS,Z
	GOTO	NastupnaPerevirka31	
	MOVLW	B'10101010'
	GOTO	KinPerevirok
NastupnaPerevirka31	
	MOVLW	D'50'
	SUBWF	X_adresa,W
	BTFSS	STATUS,Z
	GOTO	NastupnaPerevirka41	
	MOVLW	B'10101010'
	GOTO	KinPerevirok
NastupnaPerevirka41	
	MOVLW	D'60'
	SUBWF	X_adresa,W
	BTFSS	STATUS,Z
	GOTO	BezPoznDesjatkiv	
	MOVLW	B'10101010'
	GOTO	KinPerevirok
BezPoznDesjatkiv	
	MOVLW	B'10000000'
;----------------------------------------------------
KinPerevirok
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510

KinVertykalx
	CLRF	Y_adresa	
	CALL	Vst_Y_Adr		; B0 
	CALL	Vst_X_Adr		; B0    X,      1- 

	CLRF	KONTR_IND_REG ;      

   RETURN
;---------------------------------------------------------------------------------
Ochyshchennja		; B0     (  )
	CLRF	X_adresa

POVTOR
	BSF		KONTR_IND_REG,3	;         
	CALL	Vertykalx ;     KONTR_IND_REG -   .,     

	INCF	X_adresa,F
	MOVLW	D'70'			;45H = 69
	SUBWF	X_adresa,W
	BTFSC	STATUS,Z		; Z=0/1 - /  
	GOTO	KIN
	CALL	Vst_X_Adr		; B0 
	GOTO	POVTOR
KIN
	CALL	VertVisx		;    

	LOADF	X_adresa,Poch_X_Adr_Gist	; =69     
	CALL	Vst_X_Adr		; B0 

	CLRF	Y_adresa	
	CALL	Vst_Y_Adr		; B0 
	RETURN
;------------------------------------------------------------------------------
VertVisx		; B0       

	LOADF	X_adresa,D'70'
;;	BSF		KONTR_IND_REG,0	;      
;;	BSF		KONTR_IND_REG,1	;      
	BSF		KONTR_IND_REG,2	; Ҳ ²    
	CALL	Vertykalx		;
	INCF	X_adresa,F		;  
	BSF		KONTR_IND_REG,3	;  
	CALL	Vertykalx		;
	INCF	X_adresa,F		; B0 
	CALL	Vst_X_Adr		; B0 
	CALL	Nolx					;  " 0"
	CALL	PROBIL				;  " "
	INCF	Y_adresa,F		;
	CALL	Vst_Y_Adr		; B0 
	CALL	Vst_X_Adr		; B0 
	CALL	Nolx					;  " 0"
	CALL	Odyn					;  " 1"
	INCF	Y_adresa,F		;
	CALL	Vst_Y_Adr		; B0 
	CALL	Vst_X_Adr		; B0 
	CALL	Nolx					;  " 0"
	CALL	Dva					;  " 2"
	INCF	Y_adresa,F		;
	CALL	Vst_Y_Adr		; B0 
	CALL	Vst_X_Adr		; B0 
	CALL	Nolx					;  " 0"
	CALL	Try					;  " 3"

	INCF	Y_adresa,F		;
	CALL	Vst_Y_Adr		; B0 
	CALL	Vst_X_Adr		; B0 	
	LOADF 	SLRIndykaciji,D'12'	;   ,   ,    
;      
VerhnjaLinija						; 
	LOADF	PerByte,B'10000000'
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	DECFSZ	SLRIndykaciji,F
	GOTO	VerhnjaLinija
	RETURN

;***********************
; 3.²   ˲
;***********************
;---------------------------------------------------------------------------------
PROBIL		; B0   -   / (6x8)
	LOADF	SLRIndykaciji,D'6'	;   ,   ,    ,D'6'
	CLRF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	DECFSZ	SLRIndykaciji,F	;   ,   ,    ,F
	GOTO	$-3
	RETURN
;---------------------------------------------------------------------------------
VyvidCyfry		; B0    ,     CYFRA

	MOVF_F	Cyfra,SLRIndykaciji	;   ,   ,    	;
	MOVF	SLRIndykaciji,F	;   ,   ,    ,F
	BTFSS	STATUS,Z		; Z=1 -   = 0 ;  
	GOTO 	CYF1	
	CALL	Nolx			;   "0"
	GOTO	KinVyvodu
CYF1
	DECFSZ	SLRIndykaciji,F	;   ,   ,    ,F		;     -  "1"   
	GOTO 	CYF2	
	CALL	Odyn			;   "1"
	GOTO	KinVyvodu
CYF2
	DECFSZ	SLRIndykaciji,F	;   ,   ,    ,F		;     -  "2"   
	GOTO 	CYF3
	CALL	Dva			;   "2"
	GOTO	KinVyvodu
CYF3
	DECFSZ	SLRIndykaciji,F	;   ,   ,    ,F		;     -  "3"   
	GOTO 	CYF4
	CALL	Try			;   "3"
	GOTO	KinVyvodu
CYF4
	DECFSZ	SLRIndykaciji,F	;   ,   ,    ,F		;     -  "4"   
	GOTO 	CYF5
	CALL	Chotyry			;   "4"
	GOTO	KinVyvodu
CYF5
	DECFSZ	SLRIndykaciji,F	;   ,   ,    ,F		;     -  "5"   
	GOTO 	CYF6
	CALL	Pjatx			;   "5"
	GOTO	KinVyvodu
CYF6
	DECFSZ	SLRIndykaciji,F	;   ,   ,    ,F		;     -  "6"   
	GOTO 	CYF7
	CALL	Shistx			;   "6"
	GOTO	KinVyvodu
CYF7
	DECFSZ	SLRIndykaciji,F	;   ,   ,    ,F		;     -  "7"   
	GOTO 	CYF8
	CALL	Sim			;   "7"
	GOTO	KinVyvodu
CYF8
	DECFSZ	SLRIndykaciji,F	;   ,   ,    ,F		;     -  "8"   
	GOTO 	CYF9
	CALL	Visim			;   "8"
	GOTO	KinVyvodu
CYF9
	CALL	Devjatx			;   "9"
KinVyvodu


	RETURN
;---------------------------------------------------------------------------------
Nolx					; B0  " 0"
	CLRF	FSR
Vyvid_0	movlw	(NolxTbl	>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,w		;current index
	INCF	FSR,F		;next
	CALL	NolxTbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
 						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	Vyvid_0_Kin

	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	Vyvid_0
Vyvid_0_Kin
	RETURN
;---------------------------------------------------------------------------------
Odyn					; B0  " 1"
	CLRF	FSR
Vyvid_1	movlw	(OdynTbl	>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	CALL	OdynTbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
 						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	Vyvid_1_Kin
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	Vyvid_1
Vyvid_1_Kin
	RETURN
;---------------------------------------------------------------------------------
Dva					; B0  " 2"
	CLRF	FSR
Vyvid_2	movlw	(DvaTbl	>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,w		;current index
	INCF	FSR,F		;next
	CALL	DvaTbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
 						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	Vyvid_2_Kin
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	Vyvid_2
Vyvid_2_Kin
	RETURN
;---------------------------------------------------------------------------------
Try					; B0  " 3"
	CLRF	FSR
Vyvid_3	movlw	(TryTbl	>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	CALL	TryTbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
 						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	Vyvid_3_Kin
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	Vyvid_3
Vyvid_3_Kin
	RETURN
;---------------------------------------------------------------------------------
Chotyry					; B0  " 4"
	CLRF	FSR
Vyvid_4	movlw	(OdynTbl	>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	CALL	ChotyryTbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
 						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	Vyvid_4_Kin
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	Vyvid_4
Vyvid_4_Kin
	RETURN
;---------------------------------------------------------------------------------
Pjatx					; B0  " 5"
	CLRF	FSR
Vyvid_5	movlw	(OdynTbl	>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	CALL	PjatxTbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
 						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	Vyvid_5_Kin
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	Vyvid_5
Vyvid_5_Kin
	RETURN
;---------------------------------------------------------------------------------
Shistx					; B0  " 6"
	CLRF	FSR
Vyvid_6	movlw	(OdynTbl	>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	CALL	ShistxTbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
 						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	Vyvid_6_Kin
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	Vyvid_6
Vyvid_6_Kin
	RETURN
;---------------------------------------------------------------------------------
Sim					; B0  " 7"
	CLRF	FSR
Vyvid_7	movlw	(OdynTbl	>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	CALL	SimTbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
 						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	Vyvid_7_Kin
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	Vyvid_7
Vyvid_7_Kin
	RETURN
;---------------------------------------------------------------------------------
Visim					; B0  " 8"
	CLRF	FSR
Vyvid_8	movlw	(OdynTbl	>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	CALL	VisimTbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
 						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	Vyvid_8_Kin
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	Vyvid_8
Vyvid_8_Kin
	RETURN
;---------------------------------------------------------------------------------
Devjatx					; B0  " 9"
	CLRF	FSR
Vyvid_9	movlw	(OdynTbl	>>8)	;set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	CALL	DevjatxTbl		;get current character
	MOVWF	SLR7			;  W
	LOADF	SLR5,StopByte	;  ,           (B'10101010')
 						;           
	MOVF	SLR7,W		;  W
	SUBWF	SLR5,F
	BTFSC	STATUS,Z
	GOTO	Vyvid_9_Kin
	MOVWF	PerByte
	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
	GOTO	Vyvid_9
Vyvid_9_Kin
	RETURN
;---------------------------------------------------------------------------------
;Iks					;  " X"
;	CLRF	FSR
;Vyvid_X	movlw	(IksTbl	>>8)	;set PCLATH to the high order address
;	MOVWF	PCLATH		;of the table (bits 12:8)
;	MOVF	FSR,W		;current index
;	INCF	FSR,F		;next
;	CALL	IksTbl		;get current character
;	MOVWF	SLR7			;  W
;	LOADF	SLR5,StopByte	;  ,           (B'10101010')
 ;						;           
;	MOVF	SLR7,W		;  W
;	SUBWF	SLR5,F
;	BTFSC	STATUS,Z
;	GOTO	Vyvid_X_Kin
;	MOVWF	PerByte
;	CALL	PER_BYTE_DATA	; B0      PIC12F683  LCD Nokia 5510
;	GOTO	Vyvid_X
;Vyvid_X_Kin
	RETURN
;***********************
; 4. Ͳ
;***********************
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
VyrahuvSerednxogo			; B0(SLR1,SLR2,SLR3)             
	CLRF	PotSerZnach		;       ( ,  )

	MOVF	KilxkistxVymiriv,F
	BTFSC	STATUS,Z				; Z=1--->     .
	GOTO	SerVyrahuvano

	BCF		KONTR_REG,2		;   2- 0/1 -  ( )    /  
	MOVF_F	SumaDanyhByte0,SLR2	;
	MOVF_F	SumaDanyhByte1,SLR1	;
	MOVF	KilxkistxVymiriv,W	;  ,     .
	
	MOVF	SLR1,F
	BTFSC	STATUS,Z				; Z=1--->SLR1=0,     -   KONTR_REG,2 = 1
	BSF		KONTR_REG,2
Kolo1
	MOVF	KilxkistxVymiriv,W	;  ,     .
	SUBWF	SLR2,F
	BTFSC	STATUS,C				; C=0 -  ,    ,    =0
	GOTO	STANDARTNO

	BTFSS	KONTR_REG,2			; =1--->    
	GOTO	ZmenshStByte
;  䳿:   ,      - ,
;        0,5   PotSerZnach   0,5 
	MOVF_F	KilxkistxVymiriv,SLR3
	BCF		STATUS,C

	MOVF	SLR2,W
	ADDWF	KilxkistxVymiriv,W		;   W    ,     . .	
	MOVWF	SLR3				;     SLR3   
;	BCF		STATUS,C
	RRF		KilxkistxVymiriv,W		;    W     .
	BCF		W,7
	SUBWF	SLR3,W
	BTFSC	STATUS,C					; =0,      
	INCF	PotSerZnach,F		;       ( ,  )	
	GOTO	SerVyrahuvano
ZmenshStByte
 	DECF	SLR1,F
	BTFSC	STATUS,Z			; =1--->    =0
	BSF		KONTR_REG,2
	INCF	PotSerZnach,F		;       ( ,  )
	GOTO	Kolo1
STANDARTNO
	INCF	PotSerZnach,F		;       ( ,  )
	GOTO	Kolo1
SerVyrahuvano
	RETURN
;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------
UtochnennjaMinMax			; B0(SLR1)     
				;       w ,
				;     PotMin,PotMax    
	MOVWF	SLR1	;  ,       SLR1
	SUBWF	PotMin,W
	BTFSS	STATUS,C		; =1 - ,   (=),    (=)  	
	GOTO	Max
	MOVF_F	SLR1,PotMin	;
	GOTO	KinUtochnennjaMinMax
Max
	MOVF	SLR1,W
	SUBWF	PotMax,W
	BTFSC	STATUS,C		; =1 - ,   ,      	
	GOTO	KinUtochnennjaMinMax
	MOVF_F	SLR1,PotMax		;
KinUtochnennjaMinMax
	RETURN
;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------
DesPeretv			; B0      
	CLRF	Znach1			;    
	CLRF	Znach10			;    
	MOVF	ByteChisla,F			;   = 0,     
	BTFSC	STATUS,Z		; Z=0 -   
	GOTO 	KinDesPeretv
Desjatky
	MOVLW	0x0A		; =10
	SUBWF	ByteChisla,F
	BTFSC	STATUS,Z		; Z=0 -   
	GOTO 	Nemaje1	;   -10=0,    
	BTFSS	STATUS,C		; C=1 -   -   
	GOTO 	Perebor10
	INCF	Znach10,F
	GOTO	Desjatky
Nemaje1
	INCF	Znach10,F
	GOTO 	KinDesPeretv	;
Perebor10
	ADDWF	ByteChisla,F		;     (  10 )
	GOTO	Odynyci	
Odynyci
	MOVF	ByteChisla,F
	BTFSC	STATUS,Z		; Z=0 -   
	GOTO 	KinDesPeretv	;   ,   =0
Shche1
	INCF	Znach1,F			;    
	DECFSZ	ByteChisla,F
	GOTO	Shche1
KinDesPeretv
	RETURN
;---------------------------------------------------------------------------------

;*****************************
; ² (  ..)
;*****************************
;---------------------------------------------------------------------------------
TIMER1     ;  BXB0     1
           ; ,   .
		   ;(    2/   1:8)
           ;   1,048576       


;  -    -  -  - 
	BANK1
	DECFSZ	B1Sekundy,F		;   (60-00)
	GOTO	VyhidTIMER1		;
;  
	LOADF	B1Sekundy,D'60'		;      (60-00)
	DECFSZ	B1Hvylyny,F			;   (60-00)
	GOTO	VyhidTIMER1		;
	LOADF	B1Hvylyny,D'60'		;      (60-00)
; ̲ 
;    EEPROM    ϲ 
;                      ;      ( , )
;      
 	DECFSZ	B1Godyny,F		; 4    (24-00)	
	GOTO	ZakinchGodyna
	LOADF	B1Godyny,D'24'		;        (24-00)
; ̲ު ʲʲ Ĳ  ̲ 
;    EEPROM    ϲ       ( , )
;	BANK0
	CALL	BXB0DobovVymirZakinch		;  䳿 -    
;      - Ҳ ( ),       (  VymirZakincheno)
	MOVLW	D'3'			; "  - Ҳ ?"
	SUBWF	NomerRegymu,W ;      (50 , 50 , 50 , 50 )

	BTFSC	STATUS,Z		;   "3"-  (NomerRegymu="3"),   
	CALL	VymirZakincheno	;	
ZakinchGodyna
;	BANK0
	CALL	BXB0GodynVymirZakinch		;
;      -  ( ),       (  VymirZakincheno)
	MOVLW	D'2'			; "  -  ?"
	SUBWF	NomerRegymu,W ;      (50 , , , )

	BTFSC	STATUS,Z		;   "2"-  (NomerRegymu="2"),   
	CALL	VymirZakincheno	;
VyhidTIMER1
;    (34  (34,3 -     -20)
	BANK0
	DECFSZ	KilxkPeriodivT1ZaVymir,F
	GOTO	KinTIMER1
	LOADF	KilxkPeriodivT1ZaVymir,D'34' 
;    -  (  ),       (  VymirZakincheno)





	MOVLW	D'1'			; "  -  ?"
	SUBWF	NomerRegymu,W ;      (50 , 48 , 30 , 48 )
	BTFSC	STATUS,Z		;   "1"-  (NomerRegymu="1"),   
	CALL	VymirZakincheno		;        GP3

KinTIMER1
;;; в  1  Ĳ  1 
;   1   0x0B  0xDC ,
;  3036
; 1,048576 / 65536 (.   16- ) = 16
;(1,048576 - 1.)/0,000016 = 3036 = 0X0B,0xDC
	LOADF	TMR1H,0x0B           ;   1,048576   1      
	LOADF	TMR1L,0xDC	
	RETURN

;---------------------------------------------------------------------------------



;---------------------------------------------------------------------------------
Zatr100mks			; BXB0   100  . . 2M
	MOVLW	.15
	BANK1
	MOVWF	B1Zatrymka
	DECFSZ	B1Zatrymka,F  
	GOTO	$-1
	BANK0
	RETURN
;---------------------------------------------------------------------------------
Zatr1ms5BXB0    ;  1,5  . . 2M
	MOVLW	.255
	BANK1
	MOVWF	B1Zatrymka
	DECFSZ	B1Zatrymka,F  
	GOTO	$-1
	BANK0
	RETURN
;---------------------------------------------------------------------------------

;------------------------------------------------------------------------------
VhidnyjImpuls		; BXB0           GP2
;           
;     (  (),  109  ( ),  10924  ( )
;    1092430  ( )
;

	CALL    Zatr100mks		; BXB0   100  . . 2M    
	BTFSC	GPIO,2		;    -20 - 250	
	GOTO	KinVhidnyjImpuls		;   ,   - 

;  1
	MOVLW	D'1'			; "  -  ?"
	SUBWF	NomerRegymu,W ;      (50 , , , )
	BTFSS	STATUS,Z		;   "1"-  (NomerRegymu="1"),   
	GOTO	REGYM2_4	; Ͳ -      
						;      (2,3,4) 
	CALL	PotochnaZmina	;    RezPotVym, SumaDanyhByte0, SumaDanyhByte1 
			; +    (RezPotVym)  + 

REGYM2_4		; "  - _ ?"


	BANK1	
	DECFSZ	B1LichGodynUseredn,F	;   ,
	GOTO	KinVhidnyjImpuls									;   =106

;;;;;;;;;;;;; ԲӪ 	  
	BANK0
	MOVLW	D'2'			; "  -  ?"
	SUBWF	NomerRegymu,W ;      (50 , , , )
	BTFSC	STATUS,Z		;   "2"-  (NomerRegymu="2"),   
	CALL	PotochnaZmina	;    RezPotVym
			; +    (RezPotVym)  + 

;    
	MOVF	KilxkVymirivZaGodynu,W	; =106 : 3600 . /(KilxkPeriodivT1ZaVymir * PeriodT1(.))=3600/(34*1) = 106
	BANK1
	MOVWF	B1LichGodynUseredn	;   106    
	BTFSC	B1KONTR_REG2,5		;      "99"
	GOTO	PROP2
	INCF	B1PotRezZaGodynu,F	;   1       		

	MOVLW	D'99'	; 99-    
	SUBWF	B1PotRezZaGodynu,W
	BTFSC	STATUS,Z
	BSF		B1KONTR_REG2,5	;      	 "99" 

PROP2
	DECFSZ	B1LichDobovUseredn,F	;   
;						;  (106x)24  
	GOTO	KinVhidnyjImpuls									;   =106
;;;;;;;;;;;;; ԲӪ 	  
	BANK0
	MOVLW	D'3'			; "  - Ҳ ?"
	SUBWF	NomerRegymu,W ;      (50 , 48 , 30 , 48 )
	BTFSC	STATUS,Z		;   "3"-  (NomerRegymu="3"),   
	CALL	PotochnaZmina	;    RezPotVym, SumaDanyhByte0, SumaDanyhByte1 
			; +    (RezPotVym)  + 


;    
	MOVLW	D'24'
	BANK1
	MOVWF	B1LichDobovUseredn	;   
;						;  (106x)24  
	BTFSC	B1KONTR_REG3,5		;      "99"
	GOTO	PROP3
	INCF	B1PotRezZaDobu,F		;       		


	MOVLW	D'99'	; 99-    
	SUBWF	B1PotRezZaDobu,W		;       	
	BTFSC	STATUS,Z
	BSF		B1KONTR_REG3,5	;      	 "99" 

PROP3


KinVhidnyjImpuls
	BANK0
	RETURN
;------------------------------------------------------------------------------
VymirZakincheno	; B0  
				;  , ,     
				;       
;				;    ,KONTR_REG,3 = 1,    
				;    ,     
						;     '  EEPROM
						;   RezPotVym   .
				;    99 (. )	
				;         	

	BTFSC	KONTR_REG,3		; 0/1  /       
	GOTO	PravaKrajnjaPozycija		;      ,    
							;   ZsuvGrafika -       
	INCF	KilxkistxVymiriv,F	;  ,     .
;   ,         = 50
	MOVLW	D'51'
	SUBWF	KilxkistxVymiriv,W
	BTFSS	STATUS,Z
	GOTO	PravaKrajnjaPozycija
	LOADF	KilxkistxVymiriv,D'50'
	BSF		KONTR_REG,3	
	CALL	ZbilxshSumy0_ZOBR		;    ,     
						;     '  EEPROM
						;   RezPotVym   .

PravaKrajnjaPozycija			; 

	MOVF_F	FSR_PotStovpchyka,FSR
	MOVF_F	RezPotVym,INDF	;      REZULT1...70

	CALL	 ZsuvViknaTaGistogramy		;       
;					;    ,KONTR_REG,3 = 1,    

	BTFSS	KONTR_REG,3		; 0/1  /       
	INCF	FSR_PotStovpchyka,F; FSR   ( RZULT1-   - )

	CALL	ZbilxshSumy0_ZOBR		;    ,     
						;     '  EEPROM
						;   RezPotVym   .

;    - , , ,  
	BTFSC	KONTR_REG,1				;       (0 --->1-e)
	GOTO 	Utochnennja
;     
	MOVF_F	RezPotVym,PotMin	;
	MOVF_F	RezPotVym,PotMax		;
	MOVF_F	RezPotVym,PotSerZnach	;
	GOTO	MinMaxSerUtochneno
Utochnennja
	MOVF	RezPotVym,W
	CALL	UtochnennjaMinMax	;(SLR1)     
				;       w ,
	CALL	VyrahuvSerednxogo		;(SLR1,SLR2,SLR3)             
MinMaxSerUtochneno
	CALL	VyvidSerMaxMinKilxkVym		;  , ,  
										;   
	CLRF	RezPotVym

	BCF		KONTR_REG,5		;    99 (. )	
	BSF		KONTR_REG,1			;         	
	RETURN
;---------------------------------------------------------------------------------
VyvidSerMaxMinKilxkVym		; B0   , ,  
							;   
;    - , , ,  
	CALL	ZberegennjaAdr		;   X,Y 	

	LOADF	X_adresa,D'72'
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'5'
	CALL	Vst_Y_Adr		; B0 
	MOVF_F	PotSerZnach,ByteChisla
	CALL	DesPeretv		;      
	MOVF_F	Znach1,Cyfra
	CALL	VyvidCyfry
	MOVF	Znach10,F
	BTFSC	STATUS,Z		; Z=0 -   
	GOTO 	Bez100
	MOVF_F	Znach10,Cyfra
	CALL	VyvidCyfry
	GOTO 	Dali10
Bez100
	CALL	PROBIL		;   -   / (6x8)
;....................................
Dali10
	LOADF	X_adresa,D'4'
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'5'
	CALL	Vst_Y_Adr		; B0 

	MOVF_F	PotMax,ByteChisla
	CALL	DesPeretv		;      
	MOVF_F	Znach1,Cyfra
	CALL	VyvidCyfry
	MOVF	Znach10,F
	BTFSC	STATUS,Z		; Z=0 -   
	GOTO 	Bez10_20
	MOVF_F	Znach10,Cyfra
	CALL	VyvidCyfry
	GOTO 	Dali1_20
Bez10_20
	CALL	PROBIL		;   -   / (6x8)
;....................................
Dali1_20
	LOADF	X_adresa,D'20'
	CALL	Vst_X_Adr		; B0 
	LOADF	Y_adresa,D'5'
	CALL	Vst_Y_Adr		; B0 

	MOVF_F	PotMin,ByteChisla
	CALL	DesPeretv		;      
	MOVF_F	Znach1,Cyfra
	CALL	VyvidCyfry
	MOVF	Znach10,F
	BTFSC	STATUS,Z		; Z=0 -   
	GOTO 	Bez10_30
	MOVF_F	Znach10,Cyfra
	CALL	VyvidCyfry
	GOTO 	Dali1_30
Bez10_30
	CALL	PROBIL		;   -   / (6x8)
;....................................
Dali1_30
;777777777
	CALL IndKilxkVymiriv		;   ,     
	CALL	VidnovlennjaAdr		;  X,Y 
	RETURN
;---------------------------------------------------------------------------------
;IMPULSX		;     .
;	BCF		DataLine	;
;	CALL    Zatr100mks   ;  140  . . 2M
;	BSF		DataLine	;
;	CALL	Zatr100mks   ;  140  . . 2M
;	BCF		DataLine	;
;	CALL	Zatr1ms5BXB0    ;  1,5  . . 2M
;
;
;	RETURN
;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------


;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	ORG	0x6B0
;; 	ORG	0x6C8		; SUPER MINIMUM    Ͳ вͲ
; 	ORG	0x698		; MINIMUM
;	org	0x800
;	ORG	0x620
;	org	0x718
;	ORG	0x748	
;	ORG	0x750
	ORG	0x760
;---------------------------------------------------------------------------------
;VerhnjaStrokaTbl;
;	addwf	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)                                                                                                      
;	DT	B'00111000',B'01000100',B'10000010',0x00,B'01111100',B'10000010',B'10000010',B'10000010',B'01111100',0x00,B'01111100',B'10000010',B'10000010',B'10000010',B'01111100',0x00             ;;;;;    ; 00) 
;	DT	B'00010000',B'00010000',B'00010000',0x00,B'01111100',B'10000010',B'10000010',B'10000010',B'01111100',0x00,B'01111100',B'10000010',B'10000010',B'10000010',B'01111100',0x00;                     ; 00-
;	DT	B'10000010',B'01000100',B'00111000',0x00,B'00011100',B'01100010',B'10100010',B'10011100',0x00,B'00011100',B'00100010',B'00100010',B'00011100',0x00   ;                                          ; (
;	DT	B'00010010',B'00101010',B'00101010',B'00100100',B'01000000',B'00100000',B'00010000',B'000001000',B'00000100'            					                                                  ; /
;	DT	B'01110010',B'10001000',B'10001000',B'10001000',B'11111110',0x00,B'00100010',B'00010100',B'00001000',B'00111110',0x00,B'00111110',B'00010000',B'00001000',B'00010000',B'00111110',0x00			; 
;	DT	B'01111100',B'10000010',B'10000010',B'10000010',B'01111100',0x00,B'01111100',B'10000010',B'10000010',B'10000010',B'01111100',0x00,0x00,B'10101010'											; 00 
;VerhnjaStrokaTblEnd
;---------------------------------------------------------------------------------
;Reg1Str1Tbl	;    ""
;	ADDWF	PCL,F
;;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
;;		1		2	3		4			5			6			7			8		9			10			11			12			13		14				
;	DT	0x00,0x00,0x00,B'00011100',B'00010001',B'01110001',B'01000001',B'11011101',B'00010000',B'01110000',B'01000111',B'11000100',00011100,0x00,B'10101010'					; "-"
;;	DT	B'00010000',B'00010000',0x00,B'01111100',B'00010000',B'00001001',B'01111100',0x00,B'00011000',B'01100100',B'10100100',B'11111100',0x00,0x00,B'10101010'					; "-"
;Reg1Str1TblEnd
;---------------------------------------------------------------------------------
Reg1Str1Tbl	; "-"  "-"
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
;  
;	DT	B'00010000',B'00010000',0x00,B'01111100',B'00010000',B'00001001',B'01111100',0x00,B'00011000',B'01100100',B'10100100',B'11111100',0x00,0x00,B'10101010'					; "-"
;  
	DT	B'00100000',B'00100000',0x00,B'01010000',B'10101000',B'10001000',B'00010000',0x00,B'11111000',B'00100000',B'00010000',B'11111000',0x00,0x00,B'10101010'					; "-"
Reg1Str1TblEnd
;---------------------------------------------------------------------------------
;Reg1Str2Tbl	;    ""
;	ADDWF	PCL,F
;;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
;;			1			2			3			4			5			6			7			8			9			10			11			12		13		14				
;	DT	B'00110010',B'01000010',B'10000010',B'10100010',B'00010010',B'00001110',B'00000110',B'00000010',B'10000010',B'10000010',B'01000010',B'00110010',0x00,0x00,B'10101010'			; "."DT	B'01100100',B'10010000',B'10010000',B'01111100',0x00,B'01111000',0x00,B'11111000',B'01000000',B'00100000',B'01000000',B'11111000',0x00,0x00,B'10101010'			; "."
;;	DT	B'00100000',B'00100000',B'00000001',B'00000010',B'01111011',0x00,B'00000010',B'11111000',B'01000000',B'00100001',B'01000001',B'11111001',0x00,0x00,B'10101010'			; "-"
;Reg1Str2TblEnd
;---------------------------------------------------------------------------------
Reg1Str2Tbl	; "."  "."
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
;  
;	DT	B'01100100',B'10010000',B'10010000',B'01111100',0x00,B'01111000',0x00,B'11111000',B'01000000',B'00100000',B'01000000',B'11111000',0x00,0x00,B'10101010'			; "."
;  
	DT	B'01100100',B'10010000',B'10010000',B'01111100',0x00,B'10001000',B'10101000',B'11111000',0x00,B'11111000',B'01000000',B'00100000',B'01000000',B'11111000',B'10101010'			; "."

;	DT	B'00100000',B'00100000',B'00000001',B'00000010',B'01111011',0x00,B'00000010',B'11111000',B'01000000',B'00100001',B'01000001',B'11111001',0x00,0x00,B'10101010'			; "-"
Reg1Str2TblEnd
;---------------------------------------------------------------------------------
;;Reg1Str3Tbl
;;	ADDWF	PCL,F
;;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
;;	DT	0x00,B'01100000',B'10010000',B'10010000',B'11110000',0x00,B'11110000',0x00,B'10000000',B'01000000',B'01000000',B'11110000',0x00,0x00,B'10101010'						; ""
;;Reg1Str3TblEnd
;---------------------------------------------------------------------------------
Reg2Str1Tbl	; "-"  "-"
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
;  
;	DT	B'00100000',B'00100000',0x00,B'01110000',B'10001000',B'10001000',B'01110000',0x00,B'01001000',B'10101000',B'10010001',B'00000010',B'00000010',B'10101010'				; "-"
;  
	DT	B'00100000',B'00100001',B'00000010',B'01111011',B'10100000',B'10100000',B'01111000',0x00,B'11111000',B'00100000',B'00100000',B'11000000',0x00,0x00,B'10101010'				; "-"

Reg2Str1TblEnd
;---------------------------------------------------------------------------------
Reg2Str2Tbl	; ""  ""
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
;  
;	DT	B'11111000',B'00010000',B'00010000',B'11111000',0x00,B'11111000',B'00100000',B'00010000',B'11111000',0x00,B'01110000',B'10001000',B'10001000',B'01110000',B'10101010'	; ""
;  
	DT	B'01110000',B'10001000',B'10001000',B'11110000',0x00,B'01110000',B'10001000',B'10001000',B'01110000',0x00,B'01010000',B'10001000',B'10001000',B'01110000',B'10101010'	; ""
Reg2Str2TblEnd
;---------------------------------------------------------------------------------
;Reg2Str3Tbl
;	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
;	DT	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,B'10101010'
;Reg2Str3TblEnd
;---------------------------------------------------------------------------------
Reg3Str1Tbl		; 		""  "."
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
;	DT	B'00011100',B'10100010',B'10100010',B'11011100',0x00,B'01011110',0x00,B'00011100',B'01100010',B'10100010',B'10011100',0x00,0x00,0x00,B'10101010'		; 					""
;  
;	DT	B'00011100',B'10100010',B'10100010',B'11011100',0x00,B'01011110',0x00,B'01011100',B'10100010',B'10100010',B'00011100',0x00,0x00,0x00,B'10101010'		; 					""
;  
	DT	B'00001000',B'10000000',B'11111000',B'10000000',0x00,B'11110000',B'00101000',B'00101000',B'11000000',0x00,B'01010000',B'10001000',B'10001000',B'01110000',B'10101010'		; 					""

Reg3Str1TblEnd
;---------------------------------------------------------------------------------

;---------------------------------------------------------------------------------
NolxTbl			;" 0"
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DT	B'01111100',B'10000010',B'10000010',B'10000010',B'01111100',0X00,B'10101010'
;	DT	B'',B'',B'',B'',B'',0x00,B'10101010'

NolxTblEnd
;---------------------------------------------------------------------------------
OdynTbl			;" 1"
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DT	B'00000010',B'11111110',B'00100010',0x00,0x00,0x00,B'10101010'
OdynTblEnd
;---------------------------------------------------------------------------------
DvaTbl			;" 2"
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DT	B'01100010',B'10010010',B'10010010',B'10001010',B'01000110',0x00,B'10101010'
DvaTblEnd
;---------------------------------------------------------------------------------
TryTbl			;" 3"
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DT	B'01101100',B'10010010',B'10010010',B'10000010',B'01000100',0x00,B'10101010'
TryTblEnd
;---------------------------------------------------------------------------------
ChotyryTbl		;" 4"
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DT	B'00001000',B'11111110',B'01001000',B'00101000',B'00011000',0x00,B'10101010'
ChotyryEnd
;---------------------------------------------------------------------------------
PjatxTbl		;" 5"
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DT	B'00011100',B'10100010',B'10100010',B'10100010',B'11100100',0x00,B'10101010'
PjatxTblEnd
;---------------------------------------------------------------------------------
ShistxTbl		;" 6"
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DT	B'00011100',B'10100010',B'10100010',B'10100010',B'01111100',0x00,B'10101010'
ShistxTblEnd
;---------------------------------------------------------------------------------
SimTbl			;" 7"
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DT	B'11000000',B'10100100',B'10011110',B'10001000',B'10000000',0x00,B'10101010'
SimTblEnd
;---------------------------------------------------------------------------------
VisimTbl		;" 8"
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DT	B'01011100',B'10100010',B'10100010',B'10100010',B'01011100',0x00,B'10101010'
VisimTblEnd
;---------------------------------------------------------------------------------
DevjatxTbl		;" 9"
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DT	B'01111100',B'10001010',B'10001010',B'10001010',B'01110000',0x00,B'10101010'
DevjatxTblEnd
;---------------------------------------------------------------------------------
;IksTbl		;" X"
;	ADDWF	PCL,F
;;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
;	DT	B'01000100',B'00101000',B'00010000',B'00101000',B'01000100',0x00,B'10101010'
;IksTbllEnd
;---------------------------------------------------------------------------------





;---------------------------------------------------------------------------------
	END                       ; directive 'end of program'

